#!/bin/bash

if test $# -ne 5; then
  echo "Usage: pad-video-start.sh <source folder> <destination folder> <path-to-ffmpeg-folder> <working folder> <frames to append>"
  exit 1
fi

# Encoder quality - 1 is best, 31 is worst
quality=2

srcdir=$1
destdir=$2
ffmpegdir=$3
workdir=$4
num_frames=$5

scriptname=$0
scriptdir=`dirname "$0"`
pythonscript="$scriptdir/pad_video_start.py"

# This works even if file names have spaces
IFS=$'\n'
files=($(ls -1 "$srcdir"/*.mp4))
unset IFS
numFiles=${#files[@]}

for ((i=0; i<${numFiles}; i++)); do
  file=${files[i]}
  echo "Processing $file ..."
  base=`basename "$file"`
  root=${base%.mp4}
  srcfile="$srcdir/$base"
  destfile="$destdir/$root-for-ss3.mp4"
  python "$pythonscript" --tmpdir="$workdir" --ffmpegdir="$ffmpegdir" "$srcfile" "$destfile" "$num_frames"
done