# generate_html_error_files.py
# Generate individual HTML error files for each SignStream validation error code possible.
# Source document is errors.csv, itself a scaled down version of errors.xlsx.
# Both should be found in the SignSream3 repo, currently under /scripts

# TODO: can just merge this and the modification generator file - just provide file input

import os
import csv
import sys

input_file = "errors.csv"
errors_dir = "errors"

def generate(error_code, description, solution):
  os.mkdir(errors_dir + "/" + error_code)
  sys.stdout = open(errors_dir + "/" + error_code + "/index.html", 'w')
  print ( "<html>" )
  print ( "<head>" )
  print ( "<title>SignStream Error Code " + error_code + "</title>" )
  print ( "</head>" )
  print ( "<body>" )
  print ( "<h1><u>SignStream Error Code: " + error_code + "</u></h1><br>" )
  print ( "<h1><u>Description</u></h1>" )
  print ( "<h2>" + description + "</h2>" )
  print ( "<h1><u>Solution</u></h1>" )
  print ( "<h2>" + solution + "</h2>" )
  print ( "</body>" )
  print ( "</html>" )


# main:
isExist = os.path.exists(errors_dir)
if not isExist:
  os.mkdir(errors_dir)

with open(input_file) as file:
  csvreader = csv.reader(file)

  header = next(csvreader) # parse and then ignore the header

  for row in csvreader:
    error_code = row[0]
    description = row[1]
    solution = row[2]

    generate(error_code, description, solution)

exit()
