# generate_html_modification_files.py
# Generate individual HTML modification files for each SignStream validation modification code possible.
# Source document is modification.csv, itself a scaled down version of validation.xlsx.
# Both should be found in the SignSream3 repo, currently under /scripts

# TODO: can just merge this and the modification generator file - just provide file input

import os
import csv
import sys

input_file = "modifications.csv"
modifications_dir = "modifications"

def generate(modification_code, description, solution):
  os.mkdir(modifications_dir + "/" + modification_code)
  sys.stdout = open(modifications_dir + "/" + modification_code + "/index.html", 'w')
  print ( "<html>" )
  print ( "<head>" )
  print ( "<title>SignStream Modification Code " + modification_code + "</title>" )
  print ( "</head>" )
  print ( "<body>" )
  print ( "<h1><u>SignStream Modification Code: " + modification_code + "</u></h1><br>" )
  print ( "<h1><u>Description</u></h1>" )
  print ( "<h2>" + description + "</h2>" )
  print ( "<h1><u>Solution</u></h1>" )
  print ( "<h2>" + solution + "</h2>" )
  print ( "</body>" )
  print ( "</html>" )


# main:
isExist = os.path.exists(modifications_dir)
if not isExist:
  os.mkdir(modifications_dir)

with open(input_file) as file:
  csvreader = csv.reader(file)

  header = next(csvreader) # parse and then ignore the header

  for row in csvreader:
    modification_code = row[0]
    description = row[1]
    solution = row[2]

    generate(modification_code, description, solution)

exit()
