package edu.bu.signstream.codingScheme.ui.importLegacyCodingScheme;

import javax.swing.tree.DefaultMutableTreeNode;


   public class SortableTreeNode extends DefaultMutableTreeNode {
     
     public SortableTreeNode(Object userObject) {
       super(userObject);
     }
     
     public void add(SortableTreeNode newChild) {
       int cc = getChildCount();
       Comparable newObject = (Comparable)newChild.getUserObject();
       for (int i = 0; i < cc; i++) {
         SortableTreeNode child = (SortableTreeNode)getChildAt(i);
         Comparable childObject = (Comparable)child.getUserObject();
         if (newObject.compareTo(childObject) <0) {
           super.insert(newChild, i);
           return;
         }
       }
       super.add(newChild);
     }
     
     public void insert(SortableTreeNode newChild, int childIndex) {
       add(newChild);
     }
     
     public void remove() {
       SortableTreeNode parent = (SortableTreeNode)getParent();
       super.removeFromParent();
     }
     
     public void sort() {
       int cc = getChildCount();
       for (int i = 0; i < cc - 1; i++) {
         for (int j = i+1; j <= cc - 1; j++) {
           SortableTreeNode here = (SortableTreeNode)getChildAt(i);
           SortableTreeNode there = (SortableTreeNode)getChildAt(j);
           Comparable hereObject = (Comparable)here.getUserObject();
           Comparable thereObject = (Comparable)there.getUserObject();
           if (hereObject.compareTo(thereObject) > 0) {
             super.remove(here);
             super.remove(there);
             super.insert(there,i);
             super.insert(here, j);
           }
         }
       }
     }
}
