package edu.bu.signstream.common.db.ss3;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

public class SS3_2Converter extends Converter {
	
	SS3_1Validator validator = null;
	
	Document doc = null;
	
	Element rootEl = null, dbEl = null, glossWindowEl = null;

	@Override
	public SS3ValidatorConverterReturns convert(Validator validator) {
		if (validator instanceof SS3_1Validator)
			return convert((SS3_1Validator) validator);
		
		return null;
	}
	
	public SS3ValidatorConverterReturns convert(SS3_1Validator validator) {
		this.validator = validator;
		
		returns = new SS3ValidatorConverterReturns();
        returns.errors.clear();
        returns.modifications.clear();
		
    	this.doc = validator.doc;
    	
    	this.rootEl = validator.rootEl;
    	
		convertVersions();
		
		/*
		 * TBD other validations potentially to be added in the future
		 */
		
		return returns;		
	}
	
	private void convertVersions() {
		rootEl.setAttribute("SIGNSTREAM-VERSION", "3.5.0");
		addToModifications(0, "SIGNSTREAM-VERSION was updated to 3.5.0", null);
		
		rootEl.setAttribute("DATABASE-VERSION", "3.2");
		addToModifications(0, "DATABASE-VERSION was updated to 3.2", null);
	}

}
