package edu.bu.signstream.common.files;

import javax.swing.*;
import java.nio.file.Paths;

public class SSResources {
    public static final String tmpPath;
    public static final String libPath;
    public static final String resourcesPath;
    public static final String rootPath;
    public static final String xmlPath;
    public static final String signbankPath;
    public static final String collectionPath;
    public static final String infoPath;
    public static final String ffmpegPath;
    public static final String ffmpegOutputDirectoryPath;
    public static String daiSearchURL;
    public static String ssTempDirectoryPath;

    private static String normalize(String path) {
        return Paths.get(path).normalize().toAbsolutePath().toString();
    }

    static { // static initializer
        var cwd = normalize(System.getProperty("user.dir"));
        var bundled = System.getProperty("bundle") != null;

        if (bundled) {
            libPath = normalize(cwd + "/../lib");
            resourcesPath = normalize(cwd + "/../Resources");
            rootPath = normalize(cwd + "/../../..");
            infoPath = resourcesPath + "/info.txt";
            ffmpegPath = normalize(cwd + "/../lib/bin/ffmpeg");
        } else {
            libPath = cwd + "/lib";
            resourcesPath = cwd + "/resources";
            rootPath = cwd;
            infoPath = normalize(cwd + "/info.txt");
            ffmpegPath = normalize(cwd + "/lib/bin/ffmpeg");
        }

        ssTempDirectoryPath = "/tmp/SignStream/";
        ffmpegOutputDirectoryPath = ssTempDirectoryPath + ".ffmpeg/";
        tmpPath = "/tmp/SignStream";
        xmlPath = rootPath + "/newXMLfiles";
        signbankPath = rootPath + "/signbank";
        collectionPath = rootPath + "/SignStreamDatabases";
        daiSearchURL = "https://dev.dai.cs.rutgers.edu/dai/s/processsignrecognitionsignstream";

        System.out.println("libPath = " + libPath);
        System.out.println("resourcesPath = " + resourcesPath);
        System.out.println("xmlPath = " + xmlPath);
        System.out.println("signbankPath = " + signbankPath);
        System.out.println("collectionPath = " + collectionPath);
        System.out.println("infoPath = " + infoPath);
    }

    public static ImageIcon icon(String name) {
        try {
            return new ImageIcon(resourcesPath + "/icons/" + name);
        } catch (Exception e) {
            return null;
        }
    }
}
