package edu.bu.signstream.common.util;

import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.HashMap;
import java.util.Hashtable;

import javax.swing.*;

import edu.bu.signstream.grepresentation.fields.presentation.PresentationField;
import edu.bu.signstream.grepresentation.requestsHandler.SS3Singleton;

public class ErrorMessages {
    /**
     * This class contains warning messages that are used in SignStream.
     *
     * To add another message, please add
     * public static String NEW_MESSAGE_TITLE = "x";
     * where x is any unique String, and NEW_MESSAGE_TITLE is this message identifier,
     * then add warning message wording in a String array:
     * String[] newMessageWording = new String[4];
     * newMessageWording[0] = "Warning: warning line 1 ";
     * newMessageWording[1] = "warning line 2 ";
     * newMessageWording[2] = "warning line 3 ";
     * newMessageWording[3] = "warning line 4.";
     * messages.put(ErrorMessages.NEW_MESSAGE_TITLE, newMessageWording);
     *
     * To show warning message in an application, please call
     * SS3Singleton.getErrorMessages().showErrorMessage(ErrorMessages.NEW_MESSAGE_TITLE);
     */

			
	public static String EVENT_START_TIME_PRECEDE_END_TIME = "0";
	public static String EVENT_END_TIME_FOLLOW_START_TIME = "1";
	public static String CHAINS_CANNOT_OVERLAP = "2";	
//	public static String EVENT_EXTEND_BEYOND_UTTERANCE = "3";
//	public static String GLOSS_EVENT_EXTEND_BEYOND_UTTERANCE = "4";
	public static String GLOSS_CHAINS_CANNOT_OVERLAP = "5";	
	public static String UTTERANCE_START_BEFORE_MOVIE_START = "6";
	public static String UTTERANCE_END_AFTER_MOVIE_END = "7";
	public static String UTTERANCE_MAXIMAL_START_TIME = "8";
	public static String UTTERANCE_MINIMAL_END_TIME = "9";

//	public static String GESTURE_EVENT_EXTEND_BEYOND_UTTERANCE = "04";
	public static String GESTURE_CHAINS_CANNOT_OVERLAP = "05";	

	public static String SET_START_INITIAL_HOLD_CANT_DELETE_ONSET = "11";
	public static String SET_START_VALUE__CANT_DELETE_INITIAL_HOLD = "12";
	public static String SET_START_VALUE_CANT_DELETE_ONSET = "13";
	public static String SET_START_FINAL_HOLD_CANT_DELETE_VALUE = "14";
	public static String SET_START_OFFSET_CANT_DELETE_VALUE = "15";
	public static String SET_START_OFFSET_CANT_DELETE_FINAL_HOLD = "16";

	public static String SET_START_PRESTROKE_HOLD_CANT_DELETE_PREPARATION = "111";
	public static String SET_START_VALUE__CANT_DELETE_PRESTROKE_HOLD = "112";
	public static String SET_START_VALUE_CANT_DELETE_PREPARATION = "113";
	public static String SET_START_POSTSTROKE_HOLD_CANT_DELETE_VALUE = "114";
	public static String SET_START_RETRACTION_CANT_DELETE_VALUE = "115";
	public static String SET_START_RETRACTION_CANT_DELETE_POSTSTROKE_HOLD = "116";
	public static String SET_START_RELAXED_CANT_DELETE_VALUE = "117";
	public static String SET_START_RELAXED_CANT_DELETE_POSTSTROKE_HOLD = "118";
	public static String SET_START_RELAXED_CANT_DELETE_RETRACTION = "119";

	public static String SET_END_ONSET_CANT_DELETE_INITIAL_HOLD = "17";
	public static String SET_END_INITIAL_HOLD_CANT_DELETE_VALUE = "18";
	public static String SET_END_ONSET_CANT_DELETE_VALUE = "19";
	public static String SET_END_VALUE_CANT_DELETE_FINAL_HOLD = "20";
	public static String SET_END_VALUE_CANT_DELETE_OFFSET = "21";
	public static String SET_END_FINAL_HOLD_CANT_DELETE_OFFSET = "22";

	public static String SET_END_PREPARATION_CANT_DELETE_PRESTROKE_HOLD = "217";
	public static String SET_END_PREPARATION_CANT_DELETE_VALUE = "218";
	public static String SET_END_PRESTROKE_HOLD_CANT_DELETE_VALUE = "219";
	public static String SET_END_VALUE_CANT_DELETE_POSTSTROKE_HOLD = "220";
	public static String SET_END_VALUE_CANT_DELETE_RETRACTION = "221";
	public static String SET_END_VALUE_CANT_DELETE_RELAXED = "222";
	public static String SET_END_POSTSTROKE_HOLD_CANT_DELETE_RETRACTION = "223";
	public static String SET_END_POSTSTROKE_HOLD_CANT_DELETE_RELAXED = "224";
	public static String SET_END_RETRACTION_CANT_DELETE_RELAXED = "225";

	public static String ADD_FINAL_HOLD_CANT_ADJUST_OFFSET = "23";
	public static String ADD_INITIAL_HOLD_CANT_ADJUST_ONSET = "24";

	public static String ADD_POSTSTROKE_HOLD_CANT_ADJUST_RETRACTION = "323";
	public static String ADD_POSTSTROKE_HOLD_CANT_ADJUST_RELAXED = "324";
	public static String ADD_PRESTROKE_HOLD_CANT_ADJUST_PREPARATION = "325";
	
	public static String CANT_CREATE_GLOSS_WRONG_ORDER = "25";
	public static String SELECT_VALID_VIDEO_FILE = "26";

	public static String CANT_CREATE_GESTURE_WRONG_ORDER = "425";
	
	public static String CANT_LOCK_GLOSSES = "27";

	public static String CANT_LOCK_GESTURES = "27";
	
	public static String UNLOCK_GLOSS_PHON_ALIGNMENTS = "28";
	public static String UNLOCK_DOM_NDOM_HAND_ALIGNMENTS = "29";

	public static String UNLOCK_GESTURE_PHON_ALIGNMENTS = "528";
	public static String UNLOCK_GESTURE_DOM_NDOM_HAND_ALIGNMENTS = "529";
	
	public static String FUNCTIONALITY_NOT_YET_IMPLEMENTED = "30";

    public static String EVENT_NOT_SELECTED = "31";
    
    public static String CANT_EDIT_NON_SEGMENT_TIER = "32";
    public static String CANT_SELECT_DISPLAY_TIME_PERIOD = "33";
    
    public static String SET_ONE_FRAME_GLOSS_DIFF_HANDSHAPES = "34";
    public static String SELECT_HANDSHAPES_MULTIPLE = "35";
    public static String SELECT_HANDSHAPES_EXACTLY_ONE = "36";
    public static String CANT_SET_DIF_START_END_ONE_FRAME = "37";
    
    public static String CANT_EDIT_NON_TEMPORAL_PARTITION = "38";

    public static String SET_ONE_FRAME_GESTURE_DIFF_HANDSHAPES = "634";
    public static String SELECT_GESTURE_HANDSHAPES_MULTIPLE = "635";
    public static String SELECT_GESTURE_HANDSHAPES_EXACTLY_ONE = "636";
    public static String GESTURE_CANT_SET_DIF_START_END_ONE_FRAME = "637";
    public static String GESTURE_SELECT_HANDSHAPES_ORIENTATIONS = "639";
    public static String GESTURE_EMPTY_HANDSHAPES_ORIENTATIONS = "640";
    public static String GESTURE_UNIQUE_NUMBER_NOT_NULL_OR_STRING = "642";
    public static String GESTURE_UNIQUE_NUMBER_COLLISION = "643";
    public static String GESTURE_UNIQUE_NUMBER_NOT_LARGER_THAN_INT = "644";
	public static String GESTURE_HANDSHAPES_NOT_SELECTED = "645";
    
    public static String SET_ONE_FRAMES_CANNOT_OVERLAP = "700";
    
    public static String GLOSS_EMPTY_HANDSHAPES_ORIENTATIONS = "40";
    
    public static String TEXT_CONTAINS_SEGMENT_TIER_SEPARATOR = "50";

    public static String ADD_DUPLICATE_ANNOTATOR = "51";
    
    public static String GLOSS_TEXT_NO_SPACES = "52";
    
    public static String APEX_EXTENDS_PAST_GESTURE = "752";
    public static String GESTURE_APEX_BOUNDS = "753";
    
    public static String CANT_ADD_GLOSS_BETWEEN_COMPOUNDS = "754";
    
    public static String VALUE_MUST_MATCH_CHARACTERS = "755";
    
    public static String DUPLICATE_NAME_UTTERANCE = "756";

    public static String SIGNBANK_SCHEMA_VERSION_TOO_HIGH = "757";
    public static String SIGNBANK_SCHEMA_VERSION_TOO_LOW = "758";

	public static String DAI_SEARCH_INVALID_SIGNBANK_VERSION = "14000";
	public static String DAI_SEARCH_INVALID_SIGNBANK_VERSION_TITLE = "14001";
	public static String DAI_SEARCH_VIDEO_TOO_LONG = "14002";
	public static String DAI_SEARCH_VIDEO_TOO_LONG_TITLE = "14003";
	public static String DAI_SEARCH_VIDEO_FRAGMENT_CREATION_FAILED = "14004";
	public static String DAI_SEARCH_VIDEO_FRAGMENT_CREATION_FAILED_TITLE = "14005";
	public static String DAI_SEARCH_FAILED_TO_OPEN_WEB_BROWSER = "14006";
	public static String DAI_SEARCH_FAILED_TO_OPEN_WEB_BROWSER_TITLE = "14007";
	public static String DAI_SEARCH_INVALID_SIGN_SELECTION = "14008";
	public static String DAI_SEARCH_INVALID_SIGN_SELECTION_TITLE = "14009";
	public static String DAI_SEARCH_DAI_BAD_RESPONSE = "14010";
	public static String DAI_SEARCH_DAI_BAD_RESPONSE_TITLE = "14011";
	public static String DAI_SEARCH_ZERO_VIDEOS_LOADED = "14012";
	public static String DAI_SEARCH_ZERO_VIDEOS_LOADED_TITLE = "14013";
	public static String DAI_SEARCH_GENERAL_CHOICE_FAILURE = "14014";
	public static String DAI_SEARCH_GENERAL_CHOICE_FAILURE_TITLE = "14015";
	public static String DAI_SEARCH_UNKNOWN_ERROR = "14016";
	public static String DAI_SEARCH_UNKNOWN_ERROR_TITLE = "14017";
	public static String DAI_SEARCH_MISSING_SCHEMA_OR_DATA_VERSION_TITLE = "14019";
	public static final String DAI_SEARCH_MALFORMED_RESPONSE_URI = "14020";
	public static final String DAI_SEARCH_MALFORMED_RESPONSE_URI_TITLE = "14021";
	public static final String DAI_SEARCH_TIMEOUT = "14022";
	public static final String DAI_SEARCH_TIMEOUT_TITLE = "14023";
	public static final String DAI_SEARCH_CANNOT_POPULATE_SIGN = "14024";
	public static final String DAI_SEARCH_REASON_SIGN_BANK_UPDATE_NEEDED = "14025";
	public static final String DAI_SEARCH_SOLUTION_UPDATE_SIGN_BANK = "14026";


	public static String VIDEO_SPLICER_ERROR_TEMP_DIRECTORY = "15000";
	public static String VIDEO_SPLICER_ERROR_TEMP_DIRECTORY_TITLE = "15001";
	public static String VIDEO_SPLICER_ERROR_SPLICING_ERROR_SECURITY_EXCEPTION = "15003";
	public static String VIDEO_SPLICER_ERROR_TEMP_DIRECTORY_DELETION_ERROR = "15004";
	public static String VIDEO_SPLICER_ERROR_CRITICAL_ERROR_TITLE = "15006";

    
	public static String INCONSISTENT_XML_TEMPLATE_IDS = "1000";
	public static final String PALETTE_MISSING = "1001";


	private JLabel msgLabel1 = new JLabel();
	private JLabel msgLabel2 = new JLabel();
	private JLabel msgLabel3 = new JLabel();
	private JLabel msgLabel4 = new JLabel();
	
	private JDialog dialog = null;

	// TODO: Hasnain, refactor this to no longer use string arrays for all the error messages
	Hashtable<String, String[]> messages = new Hashtable<>(); // Error messages should use JOptionPane instead of JPanel and JDialog
	HashMap<String, String> errorMessages = new HashMap<>(); // Starting from now on, use this error message instead of the above messages

	HashMap<String, String> errorMessageStrings;

	public ErrorMessages() {
		this.errorMessageStrings = new HashMap<>();
//		String[] glossChainExtendBeyondUtterance = new String[4];
//		glossChainExtendBeyondUtterance[0] = "Warning: The gloss chain cannot extend beyond";
//		glossChainExtendBeyondUtterance[1] = "the start or end time of the utterance.";
//		glossChainExtendBeyondUtterance[2] = "You must adjust the boundary of the utterance";
//		glossChainExtendBeyondUtterance[3] = "and then try again.";
//		messages.put(ErrorMessages.GLOSS_EVENT_EXTEND_BEYOND_UTTERANCE, glossChainExtendBeyondUtterance);

		String[] glossChainsCannotOverlap = new String[4];
		glossChainsCannotOverlap[0] = "Warning: The gloss chain cannot overlap";
		glossChainsCannotOverlap[1] = "with another gloss chain. You must";
		glossChainsCannotOverlap[2] = "adjust the boundaries of the adjacent";
		glossChainsCannotOverlap[3] = "gloss chain and then try again.";
		messages.put(ErrorMessages.GLOSS_CHAINS_CANNOT_OVERLAP, glossChainsCannotOverlap);
		
		String[] gestureChainsCannotOverlap = new String[4];
		gestureChainsCannotOverlap[0] = "Warning: The gesture chain cannot overlap";
		gestureChainsCannotOverlap[1] = "with another gesture chain. You must";
		gestureChainsCannotOverlap[2] = "adjust the boundaries of the adjacent";
		gestureChainsCannotOverlap[3] = "gesture chain and then try again.";
		messages.put(ErrorMessages.GESTURE_CHAINS_CANNOT_OVERLAP, gestureChainsCannotOverlap);

//		String[] eventExtendBeyondUtterance = new String[4];
//		eventExtendBeyondUtterance[0] = "Warning: The event cannot extend beyond ";
//		eventExtendBeyondUtterance[1] = "the start or end time of the utterance.";
//		eventExtendBeyondUtterance[2] = "You must adjust the boundary of the ";
//		eventExtendBeyondUtterance[3] = "utterance and then try again.";
//		messages.put(ErrorMessages.EVENT_EXTEND_BEYOND_UTTERANCE, eventExtendBeyondUtterance);
		
		String[] chainsCannotOverlap = new String[4];
		chainsCannotOverlap[0] = "Warning: The events chain cannot overlap";
		chainsCannotOverlap[1] = "with another events chain. You must";
		chainsCannotOverlap[2] = "adjust the boundaries of the adjacent";
		chainsCannotOverlap[3] = "events chain and then try again.";
		messages.put(ErrorMessages.CHAINS_CANNOT_OVERLAP, chainsCannotOverlap);
		
		String[] eventStartTimePrecedeEndTime = new String[4];
		eventStartTimePrecedeEndTime[0] = "Warning: The event's start time ";
		eventStartTimePrecedeEndTime[1] = "must precede the event's end time. ";
		eventStartTimePrecedeEndTime[2] = "You must manually adjust that ";
		eventStartTimePrecedeEndTime[3] = "end time and then try again. ";
		messages.put(ErrorMessages.EVENT_START_TIME_PRECEDE_END_TIME, eventStartTimePrecedeEndTime);
		
		String[] eventEndTimeFollowsStartTime = new String[4];
		eventEndTimeFollowsStartTime[0] = "Warning: The event's end time ";
		eventEndTimeFollowsStartTime[1] = "cannot be earlier than its start time.";
		eventEndTimeFollowsStartTime[2] = "You must manually adjust that ";
		eventEndTimeFollowsStartTime[3] = "start time and then try again. ";
		messages.put(ErrorMessages.EVENT_END_TIME_FOLLOW_START_TIME, eventEndTimeFollowsStartTime);
		
		String[] utteranceStartBeforeMovieStart = new String[4];
		utteranceStartBeforeMovieStart[0] = "Warning: The utterance cannot extend beyond ";
		utteranceStartBeforeMovieStart[1] = "the start or end time of the movie.";
		utteranceStartBeforeMovieStart[2] = "You must adjust the boundary of the ";
		utteranceStartBeforeMovieStart[3] = "utterance and then try again.";
		messages.put(ErrorMessages.UTTERANCE_START_BEFORE_MOVIE_START, utteranceStartBeforeMovieStart);
		
		String[] utteranceEndAfterMovieEnd = new String[4];
		utteranceEndAfterMovieEnd[0] = "Warning: The utterance cannot extend beyond ";
		utteranceEndAfterMovieEnd[1] = "the start or end time of the movie.";
		utteranceEndAfterMovieEnd[2] = "You must adjust the boundary of the ";
		utteranceEndAfterMovieEnd[3] = "utterance and then try again.";
		messages.put(ErrorMessages.UTTERANCE_END_AFTER_MOVIE_END, utteranceEndAfterMovieEnd);

		String[] utteranceMaximalStartTime = new String[4];
		utteranceMaximalStartTime[0] = "Warning: The utterance start time cannot come after ";
		utteranceMaximalStartTime[1] = "any start time of any manual/nonmanual/translation event ";
		utteranceMaximalStartTime[2] = "contained in any of its dependent segment tiers. ";
		utteranceMaximalStartTime[3] = "Delete and/or shorten any events necessary and try again. ";
		messages.put(ErrorMessages.UTTERANCE_MAXIMAL_START_TIME, utteranceMaximalStartTime);
		
		String[] utteranceMinimalEndTime = new String[4];
		utteranceMinimalEndTime[0] = "Warning: The utterance end time cannot come before ";
		utteranceMinimalEndTime[1] = "any end time of any manual/nonmanual/translation event ";
		utteranceMinimalEndTime[2] = "contained in any of its dependent segment tiers. ";
		utteranceMinimalEndTime[3] = "Delete and/or shorten any events necessary and try again. ";
		messages.put(ErrorMessages.UTTERANCE_MINIMAL_END_TIME, utteranceMinimalEndTime);
		
		// The final hold must end before the offset ends.  Please modify the offset and try again.		

		String[] setStartInitialHoldCantDeleteOnset = new String[4];
		setStartInitialHoldCantDeleteOnset[0] = "Warning: The onset must start";
		setStartInitialHoldCantDeleteOnset[1] = "before the initial hold starts.";
		setStartInitialHoldCantDeleteOnset[2] = "Please modify the onset and try again.";
		setStartInitialHoldCantDeleteOnset[3] = "";
		messages.put(ErrorMessages.SET_START_INITIAL_HOLD_CANT_DELETE_ONSET, setStartInitialHoldCantDeleteOnset);

		String[] setStartPrestrokelHoldCantDeletePreparation = new String[4];
		setStartPrestrokelHoldCantDeletePreparation[0] = "Warning: The preparation must start";
		setStartPrestrokelHoldCantDeletePreparation[1] = "before the prestroke hold starts.";
		setStartPrestrokelHoldCantDeletePreparation[2] = "Please modify the preparation and try again.";
		setStartPrestrokelHoldCantDeletePreparation[3] = "";
		messages.put(ErrorMessages.SET_START_PRESTROKE_HOLD_CANT_DELETE_PREPARATION, setStartPrestrokelHoldCantDeletePreparation);

		String[] setStartValueCantDeleteInitialHold = new String[4];
		setStartValueCantDeleteInitialHold[0] = "Warning: The initial hold must start";
		setStartValueCantDeleteInitialHold[1] = "before the value starts. Please modify";
		setStartValueCantDeleteInitialHold[2] = "the initial hold and try again.";
		setStartValueCantDeleteInitialHold[3] = "";
		messages.put(ErrorMessages.SET_START_VALUE__CANT_DELETE_INITIAL_HOLD, setStartValueCantDeleteInitialHold);

		String[] setStartValueCantDeletePrestrokeHold = new String[4];
		setStartValueCantDeletePrestrokeHold[0] = "Warning: The pre-stroke hold must start";
		setStartValueCantDeletePrestrokeHold[1] = "before the value starts. Please modify";
		setStartValueCantDeletePrestrokeHold[2] = "the pre-stroke hold and try again.";
		setStartValueCantDeletePrestrokeHold[3] = "";
		messages.put(ErrorMessages.SET_START_VALUE__CANT_DELETE_PRESTROKE_HOLD, setStartValueCantDeletePrestrokeHold);

		String[] setStartValueCantDeleteOnset = new String[4];
		setStartValueCantDeleteOnset[0] = "Warning: The onset must start before";
		setStartValueCantDeleteOnset[1] = "the value starts.";
		setStartValueCantDeleteOnset[2] = "Please modify the onset and try again.";
		setStartValueCantDeleteOnset[3] = "";
		messages.put(ErrorMessages.SET_START_VALUE_CANT_DELETE_ONSET, setStartValueCantDeleteOnset);

		String[] setStartValueCantDeletePreparation = new String[4];
		setStartValueCantDeletePreparation[0] = "Warning: The preparation must start before";
		setStartValueCantDeletePreparation[1] = "the value starts.";
		setStartValueCantDeletePreparation[2] = "Please modify the preparation and try again.";
		setStartValueCantDeletePreparation[3] = "";
		messages.put(ErrorMessages.SET_START_VALUE_CANT_DELETE_PREPARATION, setStartValueCantDeletePreparation);

		String[] setStartFinalHoldCantDeleteValue = new String[4];
		setStartFinalHoldCantDeleteValue[0] = "Warning: The value must start";
		setStartFinalHoldCantDeleteValue[1] = "before the final hold starts.";
		setStartFinalHoldCantDeleteValue[2] = "Please modify the value and ";
		setStartFinalHoldCantDeleteValue[3] = "try again.";
		messages.put(ErrorMessages.SET_START_FINAL_HOLD_CANT_DELETE_VALUE, setStartFinalHoldCantDeleteValue);

		String[] setStartPoststrokeHoldCantDeleteValue = new String[4];
		setStartPoststrokeHoldCantDeleteValue[0] = "Warning: The value must start";
		setStartPoststrokeHoldCantDeleteValue[1] = "before the post-stroke hold starts.";
		setStartPoststrokeHoldCantDeleteValue[2] = "Please modify the value and ";
		setStartPoststrokeHoldCantDeleteValue[3] = "try again.";
		messages.put(ErrorMessages.SET_START_POSTSTROKE_HOLD_CANT_DELETE_VALUE, setStartPoststrokeHoldCantDeleteValue);

		String[] setStartOffsetCantDeleteValue = new String[4];
		setStartOffsetCantDeleteValue[0] = "Warning: The value must start";
		setStartOffsetCantDeleteValue[1] = "before the offset starts.";
		setStartOffsetCantDeleteValue[2] = "Please modify the value and ";
		setStartOffsetCantDeleteValue[3] = "try again.";
		messages.put(ErrorMessages.SET_START_OFFSET_CANT_DELETE_VALUE, setStartOffsetCantDeleteValue);

		String[] setStartRetractionCantDeleteValue = new String[4];
		setStartRetractionCantDeleteValue[0] = "Warning: The value must start";
		setStartRetractionCantDeleteValue[1] = "before the retraction starts.";
		setStartRetractionCantDeleteValue[2] = "Please modify the value and ";
		setStartRetractionCantDeleteValue[3] = "try again.";
		messages.put(ErrorMessages.SET_START_RETRACTION_CANT_DELETE_VALUE, setStartRetractionCantDeleteValue);

		String[] setStartOffsetCantDeleteFinalHold = new String[4];
		setStartOffsetCantDeleteFinalHold[0] = "Warning: The final hold must start";
		setStartOffsetCantDeleteFinalHold[1] = "before the offset starts.";
		setStartOffsetCantDeleteFinalHold[2] = "Please modify the final hold and";
		setStartOffsetCantDeleteFinalHold[3] = "try again.";
		messages.put(ErrorMessages.SET_START_OFFSET_CANT_DELETE_FINAL_HOLD, setStartOffsetCantDeleteFinalHold);

		String[] setStartOffsetCantDeletePoststrokeHold = new String[4];
		setStartOffsetCantDeletePoststrokeHold[0] = "Warning: The post-stroke hold must start";
		setStartOffsetCantDeletePoststrokeHold[1] = "before the retraction starts.";
		setStartOffsetCantDeletePoststrokeHold[2] = "Please modify the post-stroke hold and";
		setStartOffsetCantDeletePoststrokeHold[3] = "try again.";
		messages.put(ErrorMessages.SET_START_RETRACTION_CANT_DELETE_POSTSTROKE_HOLD, setStartOffsetCantDeletePoststrokeHold);
		
		String[] setStartRelaxedCantDeleteValue = new String[4];
		setStartRelaxedCantDeleteValue[0] = "Warning: The value must start";
		setStartRelaxedCantDeleteValue[1] = "before the relaxed starts.";
		setStartRelaxedCantDeleteValue[2] = "Please modify the value and";
		setStartRelaxedCantDeleteValue[3] = "try again.";
		messages.put(ErrorMessages.SET_START_RELAXED_CANT_DELETE_VALUE, setStartRelaxedCantDeleteValue);

		String[] setStartRelaxedCantDeletePoststrokeHold = new String[4];
		setStartRelaxedCantDeletePoststrokeHold[0] = "Warning: The post-stroke hold must start";
		setStartRelaxedCantDeletePoststrokeHold[1] = "before the relaxed starts.";
		setStartRelaxedCantDeletePoststrokeHold[2] = "Please modify the post-stroke hold and";
		setStartRelaxedCantDeletePoststrokeHold[3] = "try again.";
		messages.put(ErrorMessages.SET_START_RELAXED_CANT_DELETE_POSTSTROKE_HOLD, setStartRelaxedCantDeletePoststrokeHold);

		String[] setStartRelaxedCantDeleteRetraction = new String[4];
		setStartRelaxedCantDeleteRetraction[0] = "Warning: The retraction must start";
		setStartRelaxedCantDeleteRetraction[1] = "before the relaxed starts.";
		setStartRelaxedCantDeleteRetraction[2] = "Please modify the retraction and";
		setStartRelaxedCantDeleteRetraction[3] = "try again.";
		messages.put(ErrorMessages.SET_START_RELAXED_CANT_DELETE_RETRACTION, setStartRelaxedCantDeleteRetraction);

		String[] setEndOnsetCantDeleteInitialHold = new String[4];
		setEndOnsetCantDeleteInitialHold[0] = "Warning: The onset must end before";
		setEndOnsetCantDeleteInitialHold[1] = "the initial hold ends.";
		setEndOnsetCantDeleteInitialHold[2] = "Please modify the initial hold and";
		setEndOnsetCantDeleteInitialHold[3] = "try again.";
		messages.put(ErrorMessages.SET_END_ONSET_CANT_DELETE_INITIAL_HOLD, setEndOnsetCantDeleteInitialHold);

		String[] setEndPreparationCantDeletePrestrokeHold = new String[4];
		setEndPreparationCantDeletePrestrokeHold[0] = "Warning: The preparation must end before";
		setEndPreparationCantDeletePrestrokeHold[1] = "the pre-stroke hold ends.";
		setEndPreparationCantDeletePrestrokeHold[2] = "Please modify the pre-stroke hold and";
		setEndPreparationCantDeletePrestrokeHold[3] = "try again.";
		messages.put(ErrorMessages.SET_END_PREPARATION_CANT_DELETE_PRESTROKE_HOLD, setEndPreparationCantDeletePrestrokeHold);

		String[] setEndInitialHoldCantDeleteValue = new String[4];
		setEndInitialHoldCantDeleteValue[0] = "Warning: The initial hold must";
		setEndInitialHoldCantDeleteValue[1] = "end before the value ends.";
		setEndInitialHoldCantDeleteValue[2] = "Please modify the initial hold";
		setEndInitialHoldCantDeleteValue[3] = "and try again.";
		messages.put(ErrorMessages.SET_END_INITIAL_HOLD_CANT_DELETE_VALUE, setEndInitialHoldCantDeleteValue);

		String[] setEndPrestrokeHoldCantDeleteValue = new String[4];
		setEndPrestrokeHoldCantDeleteValue[0] = "Warning: The pre-stroke hold must";
		setEndPrestrokeHoldCantDeleteValue[1] = "end before the value ends.";
		setEndPrestrokeHoldCantDeleteValue[2] = "Please modify the pre-stroke hold";
		setEndPrestrokeHoldCantDeleteValue[3] = "and try again.";
		messages.put(ErrorMessages.SET_END_PRESTROKE_HOLD_CANT_DELETE_VALUE, setEndPrestrokeHoldCantDeleteValue);

		String[] setEndOnsetCantDeleteValue = new String[4];
		setEndOnsetCantDeleteValue[0] = "Warning: The onset must end before";
		setEndOnsetCantDeleteValue[1] = "the value ends.";
		setEndOnsetCantDeleteValue[2] = "Please modify the value and try again.";
		setEndOnsetCantDeleteValue[3] = "";
		messages.put(ErrorMessages.SET_END_ONSET_CANT_DELETE_VALUE, setEndOnsetCantDeleteValue);

		String[] setEndPreparationCantDeleteValue = new String[4];
		setEndPreparationCantDeleteValue[0] = "Warning: The preparation must end before";
		setEndPreparationCantDeleteValue[1] = "the value ends.";
		setEndPreparationCantDeleteValue[2] = "Please modify the value and try again.";
		setEndPreparationCantDeleteValue[3] = "";
		messages.put(ErrorMessages.SET_END_PREPARATION_CANT_DELETE_VALUE, setEndPreparationCantDeleteValue);

		String[] setEndValueCantDeleteFinalHold = new String[4];
		setEndValueCantDeleteFinalHold[0] = "Warning: The value must end before";
		setEndValueCantDeleteFinalHold[1] = "the final hold ends.";
		setEndValueCantDeleteFinalHold[2] = "Please modify the final hold and";
		setEndValueCantDeleteFinalHold[3] = "try again.";
		messages.put(ErrorMessages.SET_END_VALUE_CANT_DELETE_FINAL_HOLD, setEndValueCantDeleteFinalHold);

		String[] setEndValueCantDeletePoststrokeHold = new String[4];
		setEndValueCantDeletePoststrokeHold[0] = "Warning: The value must end before";
		setEndValueCantDeletePoststrokeHold[1] = "the post-stroke hold ends.";
		setEndValueCantDeletePoststrokeHold[2] = "Please modify the post-stroke hold and";
		setEndValueCantDeletePoststrokeHold[3] = "try again.";
		messages.put(ErrorMessages.SET_END_VALUE_CANT_DELETE_POSTSTROKE_HOLD, setEndValueCantDeletePoststrokeHold);

		String[] setEndValueCantDeleteOffset = new String[4];
		setEndValueCantDeleteOffset[0] = "Warning: The value must end ";
		setEndValueCantDeleteOffset[1] = "before the offset ends.";
		setEndValueCantDeleteOffset[2] = "Please modify the offset and";
		setEndValueCantDeleteOffset[3] = "try again.";
		messages.put(ErrorMessages.SET_END_VALUE_CANT_DELETE_OFFSET, setEndValueCantDeleteOffset);

		String[] setEndValueCantDeleteRetraction = new String[4];
		setEndValueCantDeleteRetraction[0] = "Warning: The value must end ";
		setEndValueCantDeleteRetraction[1] = "before the retraction ends.";
		setEndValueCantDeleteRetraction[2] = "Please modify the retraction and";
		setEndValueCantDeleteRetraction[3] = "try again.";
		messages.put(ErrorMessages.SET_END_VALUE_CANT_DELETE_RETRACTION, setEndValueCantDeleteRetraction);

		String[] setEndFinalHoldDeleteOffset = new String[4];
		setEndFinalHoldDeleteOffset[0] = "Warning: The final hold must end";
		setEndFinalHoldDeleteOffset[1] = "before the offset ends.";
		setEndFinalHoldDeleteOffset[2] = "Please modify the offset and";
		setEndFinalHoldDeleteOffset[3] = "try again.";
		messages.put(ErrorMessages.SET_END_FINAL_HOLD_CANT_DELETE_OFFSET, setEndFinalHoldDeleteOffset);

		String[] setEndPoststrokeHoldDeleteRetraction = new String[4];
		setEndPoststrokeHoldDeleteRetraction[0] = "Warning: The post-stroke hold must end";
		setEndPoststrokeHoldDeleteRetraction[1] = "before the retraction ends.";
		setEndPoststrokeHoldDeleteRetraction[2] = "Please modify the retraction and";
		setEndPoststrokeHoldDeleteRetraction[3] = "try again.";
		messages.put(ErrorMessages.SET_END_POSTSTROKE_HOLD_CANT_DELETE_RETRACTION, setEndPoststrokeHoldDeleteRetraction);
		
		String[] setEndValueDeleteRelaxed = new String[4];
		setEndValueDeleteRelaxed[0] = "Warning: The value must end";
		setEndValueDeleteRelaxed[1] = "before the relaxed ends.";
		setEndValueDeleteRelaxed[2] = "Please modify the relaxed and";
		setEndValueDeleteRelaxed[3] = "try again.";
		messages.put(ErrorMessages.SET_END_VALUE_CANT_DELETE_RELAXED, setEndValueDeleteRelaxed);

		String[] setEndPoststrokeDeleteRelaxed = new String[4];
		setEndPoststrokeDeleteRelaxed[0] = "Warning: The post-stroke hold must end";
		setEndPoststrokeDeleteRelaxed[1] = "before the relaxed ends.";
		setEndPoststrokeDeleteRelaxed[2] = "Please modify the relaxed and";
		setEndPoststrokeDeleteRelaxed[3] = "try again.";
		messages.put(ErrorMessages.SET_END_POSTSTROKE_HOLD_CANT_DELETE_RELAXED, setEndPoststrokeDeleteRelaxed);

		String[] setEndRetractionDeleteRelaxed = new String[4];
		setEndRetractionDeleteRelaxed[0] = "Warning: The retraction must end";
		setEndRetractionDeleteRelaxed[1] = "before the relaxed ends.";
		setEndRetractionDeleteRelaxed[2] = "Please modify the relaxed and";
		setEndRetractionDeleteRelaxed[3] = "try again.";
		messages.put(ErrorMessages.SET_END_RETRACTION_CANT_DELETE_RELAXED, setEndRetractionDeleteRelaxed);
		
		String[] addFinalHoldCantAdjustOffset = new String[4];
		addFinalHoldCantAdjustOffset[0] = "Warning: The chained event's final hold";
		addFinalHoldCantAdjustOffset[1] = "object cannot be added to accommodate ";
		addFinalHoldCantAdjustOffset[2] = "offset's end time. You must manually adjust";
		addFinalHoldCantAdjustOffset[3] = "offset's end time and then try again.";
		messages.put(ErrorMessages.ADD_FINAL_HOLD_CANT_ADJUST_OFFSET, addFinalHoldCantAdjustOffset);

		String[] addPoststrokeHoldCantAdjustRetraction = new String[4];
		addPoststrokeHoldCantAdjustRetraction[0] = "Warning: The chained event's post-stroke hold";
		addPoststrokeHoldCantAdjustRetraction[1] = "object cannot be added to accommodate ";
		addPoststrokeHoldCantAdjustRetraction[2] = "retraction's end time. You must manually adjust";
		addPoststrokeHoldCantAdjustRetraction[3] = "retraction's end time and then try again.";
		messages.put(ErrorMessages.ADD_POSTSTROKE_HOLD_CANT_ADJUST_RETRACTION, addPoststrokeHoldCantAdjustRetraction);

		String[] addPoststrokeHoldCantAdjustRelaxed = new String[4];
		addPoststrokeHoldCantAdjustRelaxed[0] = "Warning: The chained event's post-stroke hold";
		addPoststrokeHoldCantAdjustRelaxed[1] = "object cannot be added to accommodate ";
		addPoststrokeHoldCantAdjustRelaxed[2] = "relaxed's end time. You must manually adjust";
		addPoststrokeHoldCantAdjustRelaxed[3] = "relaxed's end time and then try again.";
		messages.put(ErrorMessages.ADD_POSTSTROKE_HOLD_CANT_ADJUST_RETRACTION, addPoststrokeHoldCantAdjustRelaxed);

		String[] addInitialHoldCantAdjustOnset = new String[4];
		addInitialHoldCantAdjustOnset[0] = "Warning: The entity's initial hold object";
		addInitialHoldCantAdjustOnset[1] = "cannot be added to accommodate onset's ";
		addInitialHoldCantAdjustOnset[2] = "start time. You must manually adjust onset's";
		addInitialHoldCantAdjustOnset[3] = "start time and then try again.";
		messages.put(ErrorMessages.ADD_INITIAL_HOLD_CANT_ADJUST_ONSET, addInitialHoldCantAdjustOnset);

		String[] addPrestrokeHoldCantAdjustPreparation = new String[4];
		addPrestrokeHoldCantAdjustPreparation[0] = "Warning: The entity's pre-stroke hold object";
		addPrestrokeHoldCantAdjustPreparation[1] = "cannot be added to accommodate preparation's ";
		addPrestrokeHoldCantAdjustPreparation[2] = "start time. You must manually adjust preparation's";
		addPrestrokeHoldCantAdjustPreparation[3] = "start time and then try again.";
		messages.put(ErrorMessages.ADD_PRESTROKE_HOLD_CANT_ADJUST_PREPARATION, addPrestrokeHoldCantAdjustPreparation);

		// CANT_CREATE_GLOSS_WRONG_ORDER, verify with Carol
		String[] cantCreateGlossWrongOrder = new String[4];
		cantCreateGlossWrongOrder[0] = "Warning: Can't create gloss in that order.";
		cantCreateGlossWrongOrder[1] = "";
		cantCreateGlossWrongOrder[2] = "s";
		cantCreateGlossWrongOrder[3] = "";
		messages.put(ErrorMessages.CANT_CREATE_GLOSS_WRONG_ORDER, cantCreateGlossWrongOrder);

		// CANT_CREATE_GESTURE_WRONG_ORDER, verify with Carol
		String[] cantCreateGestureWrongOrder = new String[4];
		cantCreateGestureWrongOrder[0] = "Warning: Can't create gesture in that order.";
		cantCreateGestureWrongOrder[1] = "";
		cantCreateGestureWrongOrder[2] = "s";
		cantCreateGestureWrongOrder[3] = "";
		messages.put(ErrorMessages.CANT_CREATE_GESTURE_WRONG_ORDER, cantCreateGestureWrongOrder);
		
		// "Warning: Please select at least one valid and available video file and try again."
		// SELECT_VALID_VIDEO_FILE
		String[] selectValidVideoFile = new String[4];
		selectValidVideoFile[0] = "Warning: Please select at least";
		selectValidVideoFile[1] = "one valid and available video";
		selectValidVideoFile[2] = "file and try again.";
		selectValidVideoFile[3] = "";
		messages.put(ErrorMessages.SELECT_VALID_VIDEO_FILE, selectValidVideoFile);

		// CANT_LOCK_GLOSSES
		String[] cantLockGlosses = new String[4];
		cantLockGlosses[0] = "Warning: This operation cannot be completed";
		cantLockGlosses[1] = "because it would create overlap with";
		cantLockGlosses[2] = "surrounding gloss items. Please readjust";
		cantLockGlosses[3] = "the adjacent glosses and try again.";
		messages.put(ErrorMessages.CANT_LOCK_GLOSSES, cantLockGlosses);
		
		// CANT_LOCK_GESTURES
		String[] cantLockGestures = new String[4];
		cantLockGestures[0] = "Warning: This operation cannot be completed";
		cantLockGestures[1] = "because it would create overlap with";
		cantLockGestures[2] = "surrounding gesture items. Please readjust";
		cantLockGestures[3] = "the adjacent gestures and try again.";
		messages.put(ErrorMessages.CANT_LOCK_GESTURES, cantLockGestures);

		String[] unlockGlossPhoneAlignments = new String[4];
		unlockGlossPhoneAlignments[0] = "Warning: This operation cannot";
		unlockGlossPhoneAlignments[1] = "be completed. You may wish to";
		unlockGlossPhoneAlignments[2] = "unlock Hand alignments";
		unlockGlossPhoneAlignments[3] = "for the gloss and try again.";
		messages.put(ErrorMessages.UNLOCK_GLOSS_PHON_ALIGNMENTS, unlockGlossPhoneAlignments);

		String[] unlockGesturePhoneAlignments = new String[4];
		unlockGesturePhoneAlignments[0] = "Warning: This operation cannot";
		unlockGesturePhoneAlignments[1] = "be completed. You may wish to";
		unlockGesturePhoneAlignments[2] = "unlock Hand alignments";
		unlockGesturePhoneAlignments[3] = "for the gesture and try again.";
		messages.put(ErrorMessages.UNLOCK_GESTURE_PHON_ALIGNMENTS, unlockGesturePhoneAlignments);


		String[] unlockDomNdomAlignments = new String[4];
		unlockDomNdomAlignments[0] = "Warning: This operation cannot be";
		unlockDomNdomAlignments[1] = "completed. You may wish to unlock";
		unlockDomNdomAlignments[2] = "the alignments between the glosses";
		unlockDomNdomAlignments[3] = "for the two hands and try again.";
		messages.put(ErrorMessages.UNLOCK_DOM_NDOM_HAND_ALIGNMENTS, unlockDomNdomAlignments);

		String[] unlockGestureDomNdomAlignments = new String[4];
		unlockGestureDomNdomAlignments[0] = "Warning: This operation cannot be";
		unlockGestureDomNdomAlignments[1] = "completed. You may wish to unlock";
		unlockGestureDomNdomAlignments[2] = "the alignments between the gestures";
		unlockGestureDomNdomAlignments[3] = "for the two hands and try again.";
		messages.put(ErrorMessages.UNLOCK_GESTURE_DOM_NDOM_HAND_ALIGNMENTS, unlockGestureDomNdomAlignments);
		
		//FUNCTIONALITY_NOT_YET_IMPLEMENTED
		String[] functionalityNotImplemented = new String[4];
		functionalityNotImplemented[0] = "Warning: This functionality";
		functionalityNotImplemented[1] = "is not yet implemented.";
		functionalityNotImplemented[2] = "";
		functionalityNotImplemented[3] = "";
		messages.put(ErrorMessages.FUNCTIONALITY_NOT_YET_IMPLEMENTED, functionalityNotImplemented);

        // EVENT_NOT_SELECTED
        String[] eventNotSelected = new String[4];
        eventNotSelected[0] = "Warning: This operation cannot be";
        eventNotSelected[1] = "completed. You may wish to select";
        eventNotSelected[2] = "an event or a text and try again.";
        eventNotSelected[3] = "";
        messages.put(ErrorMessages.EVENT_NOT_SELECTED, eventNotSelected);
        
        String[] cantEditNonSegmentTier = new String[4];
        cantEditNonSegmentTier[0] = "You cannot rename/delete a";
        	cantEditNonSegmentTier[1] = "Display Time Period layer";
        	cantEditNonSegmentTier[2] = "or a Temporal Partition";
    		cantEditNonSegmentTier[3] = "";
    		messages.put(ErrorMessages.CANT_EDIT_NON_SEGMENT_TIER, cantEditNonSegmentTier);
    		
    		String[] cantSelectDisplayTimePeriod = new String[4];
    		cantSelectDisplayTimePeriod[0] = "Please first select either";
    		cantSelectDisplayTimePeriod[1] = "a Temporal Partition to add under";
    		cantSelectDisplayTimePeriod[2] = "or a Segment to add after";
    		cantSelectDisplayTimePeriod[3] = "";
    		messages.put(ErrorMessages.CANT_SELECT_DISPLAY_TIME_PERIOD, cantSelectDisplayTimePeriod);

    		String[] setOneFrameGlossDiffHandshapes = new String[4];
    		setOneFrameGlossDiffHandshapes[0] = "Warning: If you want to";
    		setOneFrameGlossDiffHandshapes[1] = "create a one-frame gloss";
    		setOneFrameGlossDiffHandshapes[2] = "then both hands must have";
    		setOneFrameGlossDiffHandshapes[3] = "the same start/end handshapes.";
    		messages.put(ErrorMessages.SET_ONE_FRAME_GLOSS_DIFF_HANDSHAPES, setOneFrameGlossDiffHandshapes);

    		String[] setOneFrameGestureDiffHandshapes = new String[4];
    		setOneFrameGestureDiffHandshapes[0] = "Warning: If you want to create";
    		setOneFrameGestureDiffHandshapes[1] = "a one-frame gesture then";
    		setOneFrameGestureDiffHandshapes[2] = "both hands must have the same";
    		setOneFrameGestureDiffHandshapes[3] = "start/end handshapes and orientations.";
    		messages.put(ErrorMessages.SET_ONE_FRAME_GESTURE_DIFF_HANDSHAPES, setOneFrameGestureDiffHandshapes);

    		String[] selectHandshapesMultiple = new String[4];
    		selectHandshapesMultiple[0] = "You must select more than one";
    		selectHandshapesMultiple[1] = "handshape since this gloss";
    		selectHandshapesMultiple[2] = "is currently set to";
    		selectHandshapesMultiple[3] = "dif start/end handshapes.";
    		messages.put(ErrorMessages.SELECT_HANDSHAPES_MULTIPLE, selectHandshapesMultiple);

    		String[] selectGestureHandshapesMultiple = new String[4];
    		selectGestureHandshapesMultiple[0] = "You must select more than one";
    		selectGestureHandshapesMultiple[1] = "handshape since this gesture";
    		selectGestureHandshapesMultiple[2] = "is currently set to";
    		selectGestureHandshapesMultiple[3] = "dif start/end handshapes.";
    		messages.put(ErrorMessages.SELECT_GESTURE_HANDSHAPES_MULTIPLE, selectGestureHandshapesMultiple);

    		String[] selectHandshapesOnlyOne = new String[4];
    		selectHandshapesOnlyOne[0] = "You must select exactly one";
    		selectHandshapesOnlyOne[1] = "handshape since this gloss is";
    		selectHandshapesOnlyOne[2] = "exactly one frame long.";
    		selectHandshapesOnlyOne[3] = "";
    		messages.put(ErrorMessages.SELECT_HANDSHAPES_EXACTLY_ONE, selectHandshapesOnlyOne);

    		String[] selectGestureHandshapesOnlyOne = new String[4];
    		selectGestureHandshapesOnlyOne[0] = "You must select exactly one";
    		selectGestureHandshapesOnlyOne[1] = "handshape since this gesture is";
    		selectGestureHandshapesOnlyOne[2] = "exactly one frame long.";
    		selectGestureHandshapesOnlyOne[3] = "";
    		messages.put(ErrorMessages.SELECT_GESTURE_HANDSHAPES_EXACTLY_ONE, selectGestureHandshapesOnlyOne);
    		
    		String[] cantSetDifStartEndOneFrame = new String[4];
    		cantSetDifStartEndOneFrame[0] = "This is currently a one-frame gloss.";
    		cantSetDifStartEndOneFrame[1] = "If you want to switch to";
    		cantSetDifStartEndOneFrame[2] = "diff start/end handshapes,";
    		cantSetDifStartEndOneFrame[3] = "you must first extend the gloss.";
    		messages.put(ErrorMessages.CANT_SET_DIF_START_END_ONE_FRAME, cantSetDifStartEndOneFrame);

    		String[] gestureCantSetDifStartEndOneFrame = new String[4];
    		gestureCantSetDifStartEndOneFrame[0] = "This is currently a one-frame gesture.";
    		gestureCantSetDifStartEndOneFrame[1] = "If you want to switch to";
    		gestureCantSetDifStartEndOneFrame[2] = "diff start/end handshapes,";
    		gestureCantSetDifStartEndOneFrame[3] = "you must first extend the gesture.";
    		messages.put(ErrorMessages.GESTURE_CANT_SET_DIF_START_END_ONE_FRAME, gestureCantSetDifStartEndOneFrame);

    		String[] selectHandshapesOrientations = new String[4];
    		selectHandshapesOrientations[0] = "You must select the same number";
    		selectHandshapesOrientations[1] = "of handshape, finger tip orientation,";
    		selectHandshapesOrientations[2] = "and palm orientation representations.";
    		selectHandshapesOrientations[3] = "You can also select \"Do Not Include\" to skip an item.";
    		messages.put(ErrorMessages.GESTURE_SELECT_HANDSHAPES_ORIENTATIONS, selectHandshapesOrientations);

    		String[] emptyHandshapesOrientations = new String[4];
    		emptyHandshapesOrientations[0] = "You must select some";
    		emptyHandshapesOrientations[1] = "handshapes and orientations";
    		emptyHandshapesOrientations[2] = "on both hands for this";
    		emptyHandshapesOrientations[3] = "two-handed gesture.";
    		messages.put(ErrorMessages.GESTURE_EMPTY_HANDSHAPES_ORIENTATIONS, emptyHandshapesOrientations);

    		String[] gestureUniqueNumberNotNullorString = new String[4];
    		gestureUniqueNumberNotNullorString[0] = "You must choose a non-null, positive";
    		gestureUniqueNumberNotNullorString[1] = "integer value for the";
    		gestureUniqueNumberNotNullorString[2] = "gesture unique number.";
    		gestureUniqueNumberNotNullorString[3] = "";
    		messages.put(ErrorMessages.GESTURE_UNIQUE_NUMBER_NOT_NULL_OR_STRING, gestureUniqueNumberNotNullorString);
    		
    		String[] gestureUniqueNumberLargerThanInt = new String[4];
    		gestureUniqueNumberLargerThanInt[0] = "You must choose a";
    		gestureUniqueNumberLargerThanInt[1] = "gesture unique number";
    		gestureUniqueNumberLargerThanInt[2] = "with a lower value";
    		gestureUniqueNumberLargerThanInt[3] = "";
    		messages.put(ErrorMessages.GESTURE_UNIQUE_NUMBER_NOT_LARGER_THAN_INT, gestureUniqueNumberLargerThanInt);

			String[] gestureHandshapesNotSelected = new String[4];
			gestureHandshapesNotSelected[0] = "You must select some";
			gestureHandshapesNotSelected[1] = "handshapes for this";
			gestureHandshapesNotSelected[2] = "gesture.";
			gestureHandshapesNotSelected[3] = "";
			messages.put(ErrorMessages.GESTURE_HANDSHAPES_NOT_SELECTED, gestureHandshapesNotSelected);

    		String[] gestureUniqueNumberCollision = new String[4];
    		gestureUniqueNumberCollision[0] = "The value you have chosen";
    		gestureUniqueNumberCollision[1] = "for the gesture unique number";
    		gestureUniqueNumberCollision[2] = "is already in use by";
    		gestureUniqueNumberCollision[3] = "another gesture in this segment tier.";
    		messages.put(ErrorMessages.GESTURE_UNIQUE_NUMBER_COLLISION, gestureUniqueNumberCollision);

    		String[] oneFrameCannotOverlap = new String[4];
    		oneFrameCannotOverlap[0] = "You cannot create a one-frame";
    		oneFrameCannotOverlap[1] = "event which will overlap";
    		oneFrameCannotOverlap[2] = "with an adjacent one-frame event.";
    		oneFrameCannotOverlap[3] = "";
    		messages.put(ErrorMessages.SET_ONE_FRAMES_CANNOT_OVERLAP, oneFrameCannotOverlap);

    		String[] emptyHandshapes = new String[4];
    		emptyHandshapes[0] = "You must select some";
    		emptyHandshapes[1] = "handshapes on both hands";
    		emptyHandshapes[2] = "for this two-handed gloss.";
    		emptyHandshapes[3] = "";
    		messages.put(ErrorMessages.GLOSS_EMPTY_HANDSHAPES_ORIENTATIONS, emptyHandshapes);

    		String[] cantEditNonTemporalPartition = new String[4];
    		cantEditNonTemporalPartition[0] = "You cannot rename/delete a";
    		cantEditNonTemporalPartition[1] = "Display Time Period layer";
    		cantEditNonTemporalPartition[2] = "";
    		cantEditNonTemporalPartition[3] = "";
        	messages.put(ErrorMessages.CANT_EDIT_NON_TEMPORAL_PARTITION, cantEditNonTemporalPartition);
        		
    		String [] textContainsSegmentTierSeparator = new String[4];
    		textContainsSegmentTierSeparator[0] = "Warning: The text you have entered";
    		textContainsSegmentTierSeparator[1] = "cannot contain a colon (\":\") character";
    		textContainsSegmentTierSeparator[2] = "";
    		textContainsSegmentTierSeparator[3] = "";
    		messages.put(ErrorMessages.TEXT_CONTAINS_SEGMENT_TIER_SEPARATOR, textContainsSegmentTierSeparator);

    		String[] addDuplicateAnnotator = new String[4];
    		addDuplicateAnnotator[0] = "Error: This annotator/participant has already";
			addDuplicateAnnotator[1] = "been added to the collection. Please select a";
			addDuplicateAnnotator[2] = "different annotator/participant to add.";
			addDuplicateAnnotator[3] = "";
			messages.put(ErrorMessages.ADD_DUPLICATE_ANNOTATOR, addDuplicateAnnotator);
			
			String[] apexExtendsPastGesture = new String[4];
			apexExtendsPastGesture[0] = "Error: This action would make the apex";
			apexExtendsPastGesture[1] = "entity extend past the gesture value";
			apexExtendsPastGesture[2] = "event. Adjust apex times and try again.";
			apexExtendsPastGesture[3] = "";
			messages.put(ErrorMessages.APEX_EXTENDS_PAST_GESTURE, apexExtendsPastGesture);
			
			String[] gestureApexBounds = new String[4];
			gestureApexBounds[0] = "Error: This action could not be taken";
			gestureApexBounds[1] = "due to the apex start/end times";
			gestureApexBounds[2] = "Adjust apex times and try again.";
			gestureApexBounds[3] = "";
			messages.put(ErrorMessages.GESTURE_APEX_BOUNDS, gestureApexBounds);
			
			String[] glossTextNoSpaces = new String[4];
			glossTextNoSpaces[0] = "You must remove all spaces from the";
			glossTextNoSpaces[1] = "middle of the gloss text, except when found";
			glossTextNoSpaces[2] = "between start and end single or double quotes.";
			glossTextNoSpaces[3] = "Then try to save the gloss again.";
			messages.put(ErrorMessages.GLOSS_TEXT_NO_SPACES, glossTextNoSpaces);

			String[] cantAddGlossBetweenCompounds = new String[4];
			cantAddGlossBetweenCompounds[0] = "You cannot add a new gloss";
			cantAddGlossBetweenCompounds[1] = "between two already existing";
			cantAddGlossBetweenCompounds[2] = "glosses which are part of a";
			cantAddGlossBetweenCompounds[3] = "single compound.";
			messages.put(ErrorMessages.CANT_ADD_GLOSS_BETWEEN_COMPOUNDS, cantAddGlossBetweenCompounds);

			String[] valueMustMatchCharacters = new String[4];
			valueMustMatchCharacters[0] = "Text must only contain";
			valueMustMatchCharacters[1] = "letters and/or numbers, plus";
			valueMustMatchCharacters[2] = "any of the below characters:";
			valueMustMatchCharacters[3] = "" + Util.EXTRA_REGEX_CHARACTERS;
			messages.put(ErrorMessages.VALUE_MUST_MATCH_CHARACTERS, valueMustMatchCharacters);

			String[] duplicateNameUtterance = new String[4];
			duplicateNameUtterance[0] = "You cannot name this utterance";
			duplicateNameUtterance[1] = "the same name as another within";
			duplicateNameUtterance[2] = "this same temporal partition.";
			duplicateNameUtterance[3] = "";
			messages.put(ErrorMessages.DUPLICATE_NAME_UTTERANCE, duplicateNameUtterance);

			String[] signbankSchemaVersionTooHigh = new String[4];
			signbankSchemaVersionTooHigh[0] = "Your current version of SignStream is unable";
			signbankSchemaVersionTooHigh[1] = "to parse the installed global sign bank file.";
			signbankSchemaVersionTooHigh[2] = "Reason: the global sign bank it is too new.";
			signbankSchemaVersionTooHigh[3] = "Upgrade SignStream to use this sign bank.";
			messages.put(ErrorMessages.SIGNBANK_SCHEMA_VERSION_TOO_HIGH, signbankSchemaVersionTooHigh);

			String[] signbankSchemaVersionTooLow = new String[4];
			signbankSchemaVersionTooLow[0] = "Your current version of SignStream is unable";
			signbankSchemaVersionTooLow[1] = "to parse the installed global sign bank file.";
			signbankSchemaVersionTooLow[2] = "Reason: the global sign bank is too old.";
			signbankSchemaVersionTooLow[3] = "Upgrade the SignBank in order to use it.";
			messages.put(ErrorMessages.SIGNBANK_SCHEMA_VERSION_TOO_LOW, signbankSchemaVersionTooLow);


			String daiSignBankVersionNotLatest = "In order to perform this DAI Search, you must be using the " +
					"latest sign bank.\nCurrently, you do not have the sign bank installed. " +
					"Please restart SignStream, install the sign bank, and then try again.";

			this.errorMessageStrings.put(ErrorMessages.DAI_SEARCH_INVALID_SIGNBANK_VERSION, daiSignBankVersionNotLatest);

			String daiSignBankVersionNotLatestTitle = "Sign Bank Not Installed";
			this.errorMessageStrings.put(ErrorMessages.DAI_SEARCH_INVALID_SIGNBANK_VERSION_TITLE, daiSignBankVersionNotLatestTitle);

			String daiSearchVideoTooLong = "The length of the video selected is beyond " +
				"the maximum allowed length of 7 seconds. " +
				"To perform a DAI Search, please select a shorter range.";
			this.errorMessageStrings.put(ErrorMessages.DAI_SEARCH_VIDEO_TOO_LONG, daiSearchVideoTooLong);

			String daiSearchVideoTooLongTitle = "Video Too Long";
			this.errorMessageStrings.put(ErrorMessages.DAI_SEARCH_VIDEO_TOO_LONG_TITLE, daiSearchVideoTooLongTitle);

			String videoFragmentCreationFailed = "Video fragment creation failed and/or the video splicer faced a critical error. Please restart SignStream and try again.";
			this.errorMessageStrings.put(ErrorMessages.DAI_SEARCH_VIDEO_FRAGMENT_CREATION_FAILED, videoFragmentCreationFailed);

			String videoFragmentCreationFailedTitle = "Video Fragment Failure";
			this.errorMessageStrings.put(ErrorMessages.DAI_SEARCH_VIDEO_FRAGMENT_CREATION_FAILED_TITLE, videoFragmentCreationFailedTitle);

			String failedToOpenWebBrowser = "Failed to open web browser. Please try again. ";
			this.errorMessageStrings.put(ErrorMessages.DAI_SEARCH_FAILED_TO_OPEN_WEB_BROWSER, failedToOpenWebBrowser);

			String failedToOpenWebBrowserTitle = "Web Browser Failure";
			this.errorMessageStrings.put(ErrorMessages.DAI_SEARCH_FAILED_TO_OPEN_WEB_BROWSER_TITLE, failedToOpenWebBrowserTitle);

			String invalidSignSelected = "You did not select a valid Sign or SignStream did not detect your selection. " +
					"Please try again.";
			this.errorMessageStrings.put(ErrorMessages.DAI_SEARCH_INVALID_SIGN_SELECTION, invalidSignSelected);

			String invalidSignSelectedTitle = "DAI Search Failure";
			this.errorMessageStrings.put(ErrorMessages.DAI_SEARCH_INVALID_SIGN_SELECTION_TITLE, invalidSignSelectedTitle);


			String daiBadResponse = "DAI Search Failed. DAI Search returned an bad response. Please restart SignStream and try again.";
			this.errorMessageStrings.put(ErrorMessages.DAI_SEARCH_DAI_BAD_RESPONSE, daiBadResponse);
			String warningTitle = "DAI Search Failure";
			this.errorMessageStrings.put(ErrorMessages.DAI_SEARCH_DAI_BAD_RESPONSE_TITLE, warningTitle);

			String zeroVideosLoaded = "There are no videos in the current media player. " +
				"This should be impossible, if you are seeing this message " +
				"Something has gone horribly wrong and/or your collection file " +
				"has been corrupted. Please restart SignStream and try again.";
			this.errorMessageStrings.put(ErrorMessages.DAI_SEARCH_ZERO_VIDEOS_LOADED, zeroVideosLoaded);

			String zeroVideosLoadedTitle = "No Videos Loaded";
			this.errorMessageStrings.put(ErrorMessages.DAI_SEARCH_ZERO_VIDEOS_LOADED_TITLE, zeroVideosLoadedTitle);

			String daiSearchGeneralChoiceFailure = "DAI Video Search Failed To Get Choice From DAI Server. That is all we know at this time.";
			this.errorMessageStrings.put(ErrorMessages.DAI_SEARCH_GENERAL_CHOICE_FAILURE, daiSearchGeneralChoiceFailure);

			String daiSearchGeneralChoiceFailureTitle = "DAI Video Search Failure";
			this.errorMessageStrings.put(ErrorMessages.DAI_SEARCH_GENERAL_CHOICE_FAILURE_TITLE, daiSearchGeneralChoiceFailureTitle);

			String unknownError = "An unknown error has occurred. Please restart SignStream and try again.";
			this.errorMessageStrings.put(ErrorMessages.DAI_SEARCH_UNKNOWN_ERROR, unknownError);

			String unknownErrorTitle = "Unknown Error";
			this.errorMessageStrings.put(ErrorMessages.DAI_SEARCH_UNKNOWN_ERROR_TITLE, unknownErrorTitle);

			String missingSchemaOrDataVersionTitle = "Sign Bank Version Mismatch Failure";
			this.errorMessageStrings.put(ErrorMessages.DAI_SEARCH_MISSING_SCHEMA_OR_DATA_VERSION_TITLE, missingSchemaOrDataVersionTitle);

			String malformedURIErrorMessage = "The DAI response returned a malformed URI. Please check the log file for more details.";
			this.errorMessageStrings.put(ErrorMessages.DAI_SEARCH_MALFORMED_RESPONSE_URI, malformedURIErrorMessage);

			String malformedURIErrorTitle = "Malformed URI Error";
			this.errorMessageStrings.put(ErrorMessages.DAI_SEARCH_MALFORMED_RESPONSE_URI_TITLE, malformedURIErrorTitle);

			String videoSplicingError = "Failed to splice video [Temp Directory Error]. Please ensure that the temp directory exists and is writable. ";
			this.errorMessageStrings.put(ErrorMessages.VIDEO_SPLICER_ERROR_TEMP_DIRECTORY, videoSplicingError);

			String videoSplicingErrorTitle = "Temp Directory Error";
			this.errorMessageStrings.put(ErrorMessages.VIDEO_SPLICER_ERROR_TEMP_DIRECTORY_TITLE, videoSplicingErrorTitle);

			String videoSplicingErrorSecurityException = "Failed to splice video [Temp Directory Error - SecurityException]. Please ensure that the temp directory exists and is writable. ";
			this.errorMessageStrings.put(ErrorMessages.VIDEO_SPLICER_ERROR_SPLICING_ERROR_SECURITY_EXCEPTION, videoSplicingErrorSecurityException);

			String tempDirectoryDeletionError = "Failed to splice video [Temp Directory Error - Deletion Error]. Please ensure that the temp directory exists and is writable. ";
			this.errorMessageStrings.put(ErrorMessages.VIDEO_SPLICER_ERROR_TEMP_DIRECTORY_DELETION_ERROR, tempDirectoryDeletionError);


			String videoSplicingCriticalErrorTitle = "Video Splicing Error Critical Error";
			this.errorMessageStrings.put(ErrorMessages.VIDEO_SPLICER_ERROR_CRITICAL_ERROR_TITLE, videoSplicingCriticalErrorTitle);

			String daiSearchTimedOut = "<br>DAI Search Failed: A user selection was not made in the allotted time. <br>"
					+ "PLEASE CLOSE THE SIGN SELECTION WINDOW.<br>"
					+ "You can start again.<br><br>"
					+ "If you did not find the sign you were looking for among the choices offered,<br>"
					+ "you can try using the \"Search Sign Bank\" button in the Morph-Phon Window,<br>"
					+ "or you can try other ways of searching the DAI manually.";
			this.errorMessageStrings.put(ErrorMessages.DAI_SEARCH_TIMEOUT, daiSearchTimedOut);

			String daiSearchTimedOutTitle = "DAI Search Timed Out";
			this.errorMessageStrings.put(ErrorMessages.DAI_SEARCH_TIMEOUT_TITLE, daiSearchTimedOutTitle);

			String signCannotBePopulated = "The sign you have selected cannot be successfully entered back into SignStream.";
			this.errorMessageStrings.put(ErrorMessages.DAI_SEARCH_CANNOT_POPULATE_SIGN, signCannotBePopulated);

			String reasonSignBankUpdatedNeeded = "Reason: your current global sign bank file is outdated and needs to be updated.";
			this.errorMessageStrings.put(ErrorMessages.DAI_SEARCH_REASON_SIGN_BANK_UPDATE_NEEDED, reasonSignBankUpdatedNeeded);

			String signBankSolution = "Solution: You must update your global sign bank file. Please navigate to the menubar and select Help > Install/Update ASLLRP Sign Bank and follow the on-screen instructions.";
			this.errorMessageStrings.put(ErrorMessages.DAI_SEARCH_SOLUTION_UPDATE_SIGN_BANK, signBankSolution);

			String inconsistentXMLTemplateIDs = "The internal XML file has a mismatched default\n" +
					"template ID in the palette references. This is\n" +
					"likely a bug.";
			this.errorMessages.put(ErrorMessages.INCONSISTENT_XML_TEMPLATE_IDS, inconsistentXMLTemplateIDs);

			String paletteMissing = "The selected palette menu is missing\n" +
							"from the defCodingScheme.xml. This is\n" +
							"likely a bug.";
			this.errorMessages.put(ErrorMessages.PALETTE_MISSING, paletteMissing);

	}

	public String getErrorMessageString(String messageKey) {
		return this.errorMessageStrings.get(messageKey);
	}

	/**
	 * This method is made to use JOptionPane to display an error message since it looks nicer than the current solution in showErrorMessage using a JDialog and building the GUI manually.
	 * I have no idea what that method is doing and why one message is hard coded, I don't have time at the moment to figure it out...
	 * So, starting from now on, use this solution instead of using a string array! Just use a normal string with escape characters for new lines.
	 * @param errorMessage the error message to display
	 */
	private void showDialogErrorMessage(String errorMessage) {
		JOptionPane.showOptionDialog(SS3Singleton.getSignStreamApplication(), errorMessage, "Error", JOptionPane.DEFAULT_OPTION, JOptionPane.ERROR_MESSAGE, null, null, null);
	}
	
	public void showErrorMessage(String messageKey) {
		if (!this.messages.containsKey(messageKey)) {
			this.showDialogErrorMessage(this.errorMessages.get(messageKey));
			return;
		}

		String[] msg = messages.get(messageKey);
		
		if(msg == null) {
			return;
		}

		if (dialog == null) {

			msgLabel1.setText("Warning: The gloss chain cannot extend beyond");
			msgLabel2.setText("the start or end time of the utterance.");
			msgLabel3.setText("You must adjust the boundary of the utterance");
			msgLabel4.setText("and then try again.");

			UserInterfaceUtil.setLabelLNF(msgLabel1);
			UserInterfaceUtil.setLabelLNF(msgLabel2);
			UserInterfaceUtil.setLabelLNF(msgLabel3);
			UserInterfaceUtil.setLabelLNF(msgLabel4);

			dialog = new JDialog(SS3Singleton.getSignStreamApplication(), true);
			dialog.setTitle("Warning message");

			final JButton okBtn = new JButton("OK");

			JPanel msgPanel = new JPanel();
			GridBagConstraints gbc = new GridBagConstraints();

			msgPanel.setLayout(new GridBagLayout());
			gbc.anchor = GridBagConstraints.WEST;

			gbc.gridwidth = 3;
			gbc.gridx = 0;
			gbc.gridy = 0;
			msgPanel.add(msgLabel1, gbc);

			gbc.gridy = 1;
			gbc.gridx = 0;
			msgPanel.add(msgLabel2, gbc);

			gbc.gridy = 2;
			gbc.gridx = 0;
			msgPanel.add(msgLabel3, gbc);

			gbc.gridy = 3;
			gbc.gridx = 0;
			msgPanel.add(msgLabel4, gbc);

			gbc.gridy = 4;
			gbc.gridx = 0;
			msgPanel.add(new JLabel(" "), gbc);

			gbc.gridwidth = 1;
			gbc.anchor = GridBagConstraints.EAST;
			gbc.gridy = 5;
			gbc.gridx = 0;
			msgPanel.add(new JLabel(" "), gbc);
			gbc.gridx = 2;
			msgPanel.add(okBtn, gbc);

			okBtn.addActionListener(e -> this.dialog.setVisible(false));

			SwingUtilities.invokeLater(okBtn::requestFocus);

			Dimension d = new Dimension();
			int width = msgPanel.getPreferredSize().width + 60;
			int height = msgPanel.getPreferredSize().height + 70;

			d.setSize(width, height);
			
			dialog.setMinimumSize(d);
			dialog.setPreferredSize(d);
			dialog.getContentPane().add(msgPanel);
		}
		
		msgLabel1.setText(msg[0]);
		msgLabel2.setText(msg[1]);
		msgLabel3.setText(msg[2]);
		msgLabel4.setText(msg[3]);

		UserInterfaceUtil.setLabelLNF(msgLabel1);
		UserInterfaceUtil.setLabelLNF(msgLabel2);
		UserInterfaceUtil.setLabelLNF(msgLabel3);
		UserInterfaceUtil.setLabelLNF(msgLabel4);
		
		JPanel panel = SS3Singleton.getSignStreamApplication().getSignStreamSegmentPanel().getUtteranceView();
		
		if(SS3Singleton.getMediaToolBar(null).selectedField() instanceof PresentationField) {
			panel = SS3Singleton.getSignStreamApplication().getSignStreamSegmentPanel().getDatabaseView();
		}
		
		dialog.setLocation(250, 250);
		dialog.setLocationRelativeTo(panel);
		dialog.setVisible(true);
	}

	private JPopupMenu saveCollectionPopup = null;
	private JLabel cMsgLabel1 = new JLabel();
	private JLabel cMsgLabel2 = new JLabel();
	private JLabel cMsgLabel3 = new JLabel();
	private JLabel cMsgLabel4 = new JLabel();
	
	public void showSaveCollectionErrorMessage(String[] msg) {	
		if(msg == null) {
			return;
		}

		if (saveCollectionPopup == null) {
			
			String str1 = "Use any character for a collection name, except for the following:";
			String str2 = "- reserved characters: < > : \" / \\| ? *";
			String str3 = "- integer value zero";
			String str4 = "- Do not use the following reserved device names:";
			String str5 = "CON, PRN, AUX, NUL, COM1, COM2, COM3, COM4, COM5,";
			String str6 = "COM6, COM7, COM8, COM9, LPT1, LPT2, LPT3, LPT4,";
			String str7 = "LPT5, LPT6, LPT7, LPT8, and LPT9";
			
			cMsgLabel1.setText("Warning: The gloss chain cannot extend beyond");
			cMsgLabel2.setText("the start or end time of the utterance.");
			cMsgLabel3.setText("You must adjust the boundary of the utterance");
			cMsgLabel4.setText("and then try again.");

			UserInterfaceUtil.setLabelLNF(cMsgLabel1);
			UserInterfaceUtil.setLabelLNF(cMsgLabel2);
			UserInterfaceUtil.setLabelLNF(cMsgLabel3);
			UserInterfaceUtil.setLabelLNF(cMsgLabel4);
			
			JLabel l1 = new JLabel(str1);
			JLabel l2 = new JLabel(str2);
			JLabel l3 = new JLabel(str3);
			JLabel l4 = new JLabel(str4);
			JLabel l5 = new JLabel(str5);
			JLabel l6 = new JLabel(str6);
			JLabel l7 = new JLabel(str7);
			
			UserInterfaceUtil.setLabelLNF(l1);
			UserInterfaceUtil.setLabelLNF(l2);
			UserInterfaceUtil.setLabelLNF(l3);
			UserInterfaceUtil.setLabelLNF(l4);
			UserInterfaceUtil.setLabelLNF(l5);
			UserInterfaceUtil.setLabelLNF(l6);
			UserInterfaceUtil.setLabelLNF(l7);

			saveCollectionPopup = new JPopupMenu();

			final JButton okBtn = new JButton("OK");

			JPanel msgPanel = new JPanel();
			GridBagConstraints gbc = new GridBagConstraints();

			msgPanel.setLayout(new GridBagLayout());
			gbc.anchor = GridBagConstraints.WEST;

			gbc.gridwidth = 3;
			gbc.gridx = 0;
			gbc.gridy = 0;
			msgPanel.add(cMsgLabel1, gbc);

			gbc.gridy = 1;
			gbc.gridx = 0;
			msgPanel.add(cMsgLabel2, gbc);

			gbc.gridy = 2;
			gbc.gridx = 0;
			msgPanel.add(cMsgLabel3, gbc);

			gbc.gridy = 3;
			gbc.gridx = 0;
			msgPanel.add(cMsgLabel4, gbc);

			gbc.gridy = 4;
			gbc.gridx = 0;
			msgPanel.add(new JLabel(" "), gbc);
			
			gbc.gridy = 5;
			gbc.gridx = 0;
			msgPanel.add(l1, gbc);

			gbc.gridy = 6;
			gbc.gridx = 0;
			msgPanel.add(l2, gbc);

			gbc.gridy = 7;
			gbc.gridx = 0;
			msgPanel.add(l3, gbc);

			gbc.gridy = 8;
			gbc.gridx = 0;
			msgPanel.add(l4, gbc);

			gbc.gridy = 9;
			gbc.gridx = 0;
			msgPanel.add(l5, gbc);

			gbc.gridy = 10;
			gbc.gridx = 0;
			msgPanel.add(l6, gbc);

			gbc.gridy = 11;
			gbc.gridx = 0;
			msgPanel.add(l7, gbc);

			gbc.gridwidth = 1;
			gbc.anchor = GridBagConstraints.EAST;
			gbc.gridy = 12;
			gbc.gridx = 0;
			msgPanel.add(new JLabel(" "), gbc);
			gbc.gridx = 2;
			msgPanel.add(okBtn, gbc);

			okBtn.addActionListener(new ActionListener() {
				@Override
				public void actionPerformed(ActionEvent e) {
					saveCollectionPopup.setVisible(false);
				}
			});

			SwingUtilities.invokeLater(new Runnable() {
				@Override
				public void run() {
					okBtn.requestFocus();
				}
			});

			Dimension d = new Dimension();
			int width = msgPanel.getPreferredSize().width + 30;
			int height = msgPanel.getPreferredSize().height + 20;

			d.setSize(width, height);

			saveCollectionPopup.add(msgPanel);
			saveCollectionPopup.setPopupSize(d);
		}
		
		cMsgLabel1.setText(msg[0]);
		cMsgLabel2.setText(msg[1]);
		cMsgLabel3.setText(msg[2]);
		cMsgLabel4.setText(msg[3]);

		UserInterfaceUtil.setLabelLNF(msgLabel1);
		UserInterfaceUtil.setLabelLNF(msgLabel2);
		UserInterfaceUtil.setLabelLNF(msgLabel3);
		UserInterfaceUtil.setLabelLNF(msgLabel4);
		
		JPanel panel = SS3Singleton.getSignStreamApplication().getSignStreamSegmentPanel().getUtteranceView();
		// popup.show(field.getSignStreamSegmentPanel().getUtteranceView(), 250, 250);
		if(panel != null) {
			panel = SS3Singleton.getSignStreamApplication().getSignStreamSegmentPanel().getDatabaseView();
		}
		saveCollectionPopup.show(panel, 250, 250);
		saveCollectionPopup.setVisible(true);
	}
}
