package edu.bu.signstream.common.util;

public class Pair<S, T> {
    private Pair(S first, T second) {
        this.first = first;
        this.second = second;
    }
    public static <S, T> Pair<S, T> of(S first, T second) {
        return new Pair<>(first, second);
    }

    public final S first;
    public final T second;

    @Override
    public boolean equals(Object obj) {
        if (!(obj instanceof Pair))
            return false;

        var o = (Pair<?, ?>)obj;
        return first.equals(o.first) && second.equals(o.second);
    }

    @Override
    public String toString() {
        return "Pair{" + first.toString() + ", " + second.toString() + "}";
    }

    @Override
    public int hashCode() {
        return first.hashCode() + second.hashCode();
    }
}
