package edu.bu.signstream.common.util.vo.ss3.db;

import edu.bu.signstream.time.TimeRange;

import java.awt.Color;
import java.util.ArrayList;
import java.util.Comparator;

public class SS3StatementField extends SS3Element {
    public SS3StatementField() {}
   
   private ArrayList<SS3Entity> ss3Entities = new ArrayList<SS3Entity>();
   
   private Color color = null;

   private TimeRange timeRange;
   
   public ArrayList<SS3Entity> getSS3Entities() {	   
	   return ss3Entities;
   }
   
   public void setSS3Entities(ArrayList<SS3Entity> list) {
	   ss3Entities = new ArrayList<SS3Entity>(list);

       ss3Entities.sort(Comparator.comparing(SS3Entity::getStartTimeInfo));
   }

   	public Color getColor() {
	   return color;
	}
	
	public void setColor(Color color) {
		this.color = color;
	}

    public TimeRange getTimeRange() { return timeRange; }
    public void setTimeRange(TimeRange range) { this.timeRange = range; }

    /**
     * DO NOT call this method from within a loop, as it will sort the list.
     * Instead, make a list on the client side adding each SS3Entity object to that list,
     * then call the setSS3Entities(list) method to avoid sorting for each entry.
     * @param ss3Entity
     */
	public void addSS3Entity(SS3Entity ss3Entity) {
		ss3Entities.add(ss3Entity);
        ss3Entities.sort(Comparator.comparing(SS3Entity::getStartTimeInfo));
	}
   
   public void removeSS3Entity(SS3Entity ss3Entity) {
	   ss3Entities.remove(ss3Entity);
   }

   @Override
public String toString() {
      StringBuffer bf = new StringBuffer();
      bf.append("SS3StatementField: ");
      bf.append("id (field ID) = ");
      bf.append(getId());
      bf.append(", entityIDs = ");
      
      for (int i = 0; i < ss3Entities.size(); i++) {
    	  	SS3Entity ss3Entity = ss3Entities.get(i);
          String id = ss3Entity.getID();
          bf.append(id);
          bf.append("  ");
       }

      return bf.toString();
   }
}
