package edu.bu.signstream.common.util.vo.ss3.db;

import java.util.*;

public class SS3Track extends SS3Element {
   private HashMap<String, SS3Entity> entities = new HashMap<String, SS3Entity>();
   
   public void removeEntities() {
      entities.clear();      
   }
   
   public void clear() {
      entities.clear();
   }

   public ArrayList<SS3Entity> getEntities() {
      ArrayList<SS3Entity> list = new ArrayList<SS3Entity>();
      
      Iterator<Map.Entry<String, SS3Entity>> i = entities.entrySet().iterator();
      while(i.hasNext()){
        Map.Entry<String, SS3Entity> me = i.next();
        list.add(me.getValue());
      }
      return list;
   }
   
   

   public void addEntity(SS3Entity entity) {
      entities.put(entity.getID(), entity);
   }

   // Return true/false for whether the entity was deleted or not.
   public SS3Entity removeSS3Entity(String entityID) {
       return entities.remove(entityID);
   }
   
   public SS3Entity getSS3Entity(String entityID) {
      return entities.get(entityID);
   }

   public double getStartTime() {
      ArrayList<SS3Entity> lEntities = getEntities();
      if(lEntities.isEmpty()) 
    	  return -1;
      
      Iterator<SS3Entity> iter = lEntities.iterator();
      double startTime = iter.next().getStartTime();
      while(iter.hasNext()) {
    	  double time = iter.next().getStartTime();
          startTime = startTime < time ? startTime : time;
      }

      return startTime;
   }

   public double getEndTime() {
      ArrayList<SS3Entity> lEntities = getEntities();
      
      if(lEntities.isEmpty()) 
    	  return -1;
      
      Iterator<SS3Entity> iter = lEntities.iterator();
      double endTime = iter.next().getEndTime();
      while(iter.hasNext()) {
    	  double time = iter.next().getEndTime();
    	  endTime = endTime < time ? endTime : time;
      }
 
      return endTime;
   }
   
   public SS3Entity getSS3EntityWithRefID(String id) {
	   if(id == null)
		   return null;
	   ArrayList<SS3Entity> ents = getEntities();
	   for(SS3Entity ent:ents) {
		   String correspondingID = ent.getRefEntityId(); //.getCorrespondingGlossEntityID();
		   if(id.equalsIgnoreCase(correspondingID)) {
			   return ent;
		   }
	   }
	   return null;
   }
   
   // GD: commenting as unused 2021-07-15
//   public void updateTrack(SS3Track track) {
//      ArrayList<SS3Entity> nEntities = track.getEntities();
//      
//      for(int i = 0; i < nEntities.size(); i++) {
//         SS3Entity nEntity = nEntities.get(i);
//         SS3Entity entity = getSS3Entity(nEntity.getID());
//         if(entity != null) {
//            entity.setParticipantID(nEntity.getParticipantID());
//            //entity.removeItems();
//            entity.setItems(nEntity.getItems());
//            entity.setRefEntityId(nEntity.getRefEntityId());
//            entity.setReference(nEntity.getReference());
//            entity.setTimeUpdated(nEntity.getTimeUpdated());
//         } else {
//            entities.put(nEntity.getID(), nEntity);
//         }
//      }
//   }
}
