package edu.bu.signstream.grepresentation.fields.gestureField.dialog;

import java.util.ArrayList;

import edu.bu.signstream.common.util.vo.ss3.codingScheme.SS3CodingScheme;
import edu.bu.signstream.grepresentation.fields.gestureField.GestureEntityProperties;
import edu.bu.signstream.grepresentation.fields.gestureField.GestureFieldWrapper;
import edu.bu.signstream.grepresentation.fields.gestureField.dialog.handShapes.OrientationImage;
import edu.bu.signstream.grepresentation.fields.handShapeField.dialogs.HandShapeImage;

public class GestureHandShapeFormBean {
	private SS3CodingScheme cs = null;
	private GestureFieldWrapper gestFieldWrapper = null;

	private boolean fingerspelledSelected = false;
	private boolean fingerspelledR = false;

	private boolean oneHandedSelected = false;
	private boolean oneHandedR = false;

	private char type;

	private ArrayList<HandShapeImage> slctDomHandShapeImages = new ArrayList<>();
	private ArrayList<HandShapeImage> slctNdomHandShapeImages = new ArrayList<>();
	
	private ArrayList<OrientationImage> slctDomOrientationFingerTipImages = new ArrayList<>();
	private ArrayList<OrientationImage> slctNdomOrientationFingerTipImages = new ArrayList<>();
	private ArrayList<OrientationImage> slctDomOrientationPalmImages = new ArrayList<>();
	private ArrayList<OrientationImage> slctNdomOrientationPalmImages = new ArrayList<>();
	
	private GestureEntityProperties properties;
	
	public void setGestureEntityProperties(GestureEntityProperties properties) {
		this.properties = properties;
	}
	
	public GestureEntityProperties getGestureEntityProperties() {
		return properties;
	}

	public SS3CodingScheme getSS3CodingScheme() {
		return cs;
	}

	public void setSS3CodingScheme(SS3CodingScheme cs) {
		this.cs = cs;
	}

	public boolean isRightHandSelected() {
		if (fingerspelledSelected && fingerspelledR) {
			return fingerspelledR;
		} else if (oneHandedSelected && oneHandedR) {
			return oneHandedR;
		}
		return false;
	}

	public boolean isTwoHanded() {
		return !this.oneHandedSelected;
	}

	public void setSelectedDomHandShapeImages(
			ArrayList<HandShapeImage> handShapes) {
		this.slctDomHandShapeImages.clear();
		this.slctDomHandShapeImages.addAll(handShapes);
	}

	public void setSelectedNdomHandShapeImages(
			ArrayList<HandShapeImage> handShapes) {
		this.slctNdomHandShapeImages.clear();
		this.slctNdomHandShapeImages.addAll(handShapes);
	}

	public ArrayList<HandShapeImage> getSelectedDomHandShapeImages() {
		return slctDomHandShapeImages;
	}

	public ArrayList<HandShapeImage> getSelectedNdomHandShapeImages() {
		return slctNdomHandShapeImages;
	}
	
	public void setSelectedDomOrientationFingerTipImages(
			ArrayList<OrientationImage> orientations) {
		this.slctDomOrientationFingerTipImages.clear();
		this.slctDomOrientationFingerTipImages.addAll(orientations);
	}

	public void setSelectedNdomOrientationFingerTipImages(
			ArrayList<OrientationImage> orientations) {
		this.slctNdomOrientationFingerTipImages.clear();
		this.slctNdomOrientationFingerTipImages.addAll(orientations);
	}

	public void setSelectedDomPalmOrientationImages(
			ArrayList<OrientationImage> orientations) {
		this.slctDomOrientationPalmImages.clear();
		this.slctDomOrientationPalmImages.addAll(orientations);
	}

	public void setSelectedNdomPalmOrientationImages(
			ArrayList<OrientationImage> orientations) {
		this.slctNdomOrientationPalmImages.clear();
		this.slctNdomOrientationPalmImages.addAll(orientations);
	}

	public ArrayList<OrientationImage> getSelectedDomOrientationFingerTipImages() {
		return slctDomOrientationFingerTipImages;
	}

	public ArrayList<OrientationImage> getSelectedNdomOrientationFingerTipImages() {
		return slctNdomOrientationFingerTipImages;
	}

	public ArrayList<OrientationImage> getSelectedDomPalmOrientationImages() {
		return slctDomOrientationPalmImages;
	}

	public ArrayList<OrientationImage> getSelectedNdomPalmOrientationImages() {
		return slctNdomOrientationPalmImages;
	}

	/**
	 * @param b
	 */
	public void setFingerspelledR(boolean b) {
		fingerspelledR = b;
	}

	/**
	 * @param b
	 */
	public void setFingerspelledSelected(boolean b) {
		fingerspelledSelected = b;
	}

	/**
	 * @param b
	 */
	public void setOneHandedR(boolean b) {
		oneHandedR = b;
	}

	/**
	 * @param b
	 */
	public void setOneHandedSelected(boolean b) {
		oneHandedSelected = b;
	}

	/**
	 * @param c
	 */
	public void setType(char c) {
		type = c;
	}

	/**
	 * @return
	 */
	public char getType() {
		return type;
	}

	/**
	 * @return
	 */
	public GestureFieldWrapper getGestFieldWrapper() {
		return gestFieldWrapper;
	}

	/**
	 * @param wrapper
	 */
	public void setGestFieldWrapper(GestureFieldWrapper wrapper) {
		gestFieldWrapper = wrapper;
	}
}
