package edu.bu.signstream.grepresentation.fields.gestureField.dialog.handShapes;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Image;
import java.awt.Insets;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.ArrayList;
import java.util.HashMap;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JPanel;

import edu.bu.signstream.common.util.UIPalette;
import edu.bu.signstream.common.util.vo.ss3.codingScheme.SS3CodingScheme;
import edu.bu.signstream.common.util.vo.ss3.codingScheme.SS3FieldValue;
import edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields.FieldValueWrapper;
import edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields.PalettePanel;
import edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields.SameWidhtIcon;
import edu.bu.signstream.grepresentation.fields.handShapeField.dialogs.HandShapeImage;
import edu.bu.signstream.grepresentation.fields.handShapeField.dialogs.HandShapePalletClient;

public class GestureHandshapesPalette extends PalettePanel {

	private static final long serialVersionUID = 1L;

	private HandShapePalletClient hsClient;
	
	private SS3CodingScheme defaultCodingScheme;

	private HashMap<String, SS3FieldValue> hm = new HashMap<String, SS3FieldValue>();
	
	private JPanel handshapesPanel = new JPanel();
//	JScrollPane scrollPane = new JScrollPane(handshapesPanel);
	
	ArrayList<FieldValueWrapper> hsRow1 = new ArrayList<FieldValueWrapper>();
	ArrayList<FieldValueWrapper> hsRow2 = new ArrayList<FieldValueWrapper>();
	ArrayList<FieldValueWrapper> hsRow3 = new ArrayList<FieldValueWrapper>();

	public GestureHandshapesPalette(ArrayList<SS3FieldValue> handshapes,
			HandShapePalletClient hsClient, SS3CodingScheme defaultCodingScheme) {
		this.hsClient = hsClient;
		this.defaultCodingScheme = defaultCodingScheme;

		for (int i = 0; i < handshapes.size(); i++) {
			Object obj = handshapes.get(i);
			SS3FieldValue value = (SS3FieldValue) obj;
			hm.put(value.getId(), value);
		}

		populate();
		initUI();
	}

	private void initUI() {
		setLayout(new GridBagLayout());

		handshapesPanel.setLayout(new GridBagLayout());

		GridBagConstraints c = new GridBagConstraints();

		c.insets = new Insets(1, 1, 1, 1);

		populateHahdshapesPanel();

		//scrollPane.setPreferredSize(new Dimension(ddd.width + 10, 500));
		
//		scrollPane.setPreferredSize(new Dimension(450, 150));
//		scrollPane.getViewport().setScrollMode(javax.swing.JViewport.SIMPLE_SCROLL_MODE);

		c.gridwidth = 1;
		c.gridy = 1;
		c.gridx = 1;
		add(handshapesPanel, c);
	}

	private void populateHahdshapesPanel() {
		handshapesPanel.removeAll();
		handshapesPanel.setBackground(UIPalette.getBackground());

		GridBagConstraints c = new GridBagConstraints();
		c.insets = new Insets(5, 5, 5, 5);
		c.gridwidth = 1;
		c.weighty = 1;
		c.gridy = 0;
		c.anchor = GridBagConstraints.NORTHWEST;
		int maxHSRowSize = Math.max(hsRow1.size(), Math.max(hsRow2.size(), hsRow3.size()));
		for (int i = 0; i < maxHSRowSize; i++) {
			SS3FieldValue valueRow1 = hsRow1.get(i).getSS3FieldValue();
			SS3FieldValue valueRow2 = hsRow2.get(i).getSS3FieldValue();
			SS3FieldValue valueRow3 = hsRow3.get(i).getSS3FieldValue();
			c.gridx = i;
			
			c.gridy = 0;
			JLabel l1 = getHandhsapeVisualRepresentation(valueRow1);
			handshapesPanel.add(l1, c);
			
			c.gridy = 1;
			JLabel l2 = getHandhsapeVisualRepresentation(valueRow2);
			handshapesPanel.add(l2, c);
			
			c.gridy = 2;
			JLabel l3 = getHandhsapeVisualRepresentation(valueRow3);
			handshapesPanel.add(l3, c);
		}
		
		c.gridx = 4;
		c.gridy = 0;
		c.gridheight = 2;
		FieldValueWrapper fvw = createFieldValueWrapper("999", "HSH_999", "donotinclude", false, false, color1);
		JLabel dniHsLabel = getHandhsapeVisualRepresentation(fvw.getSS3FieldValue());
		dniHsLabel.setOpaque(true);
		dniHsLabel.setBackground(new Color(169, 209, 228));
		dniHsLabel.setBorder(BorderFactory.createStrokeBorder(new BasicStroke(1)));
		handshapesPanel.add(dniHsLabel, c);
	}
	
	private static final Color color2 = new Color(255, 255, 255);
	private static final Color color1 = new Color(123, 166, 172);
	
	private void populate() {

		hsRow1.add(createFieldValueWrapper("1", "HSH_001", "1", false, false, color1));
		hsRow1.add(createFieldValueWrapper("18","HSH_018", "B-L", false, false, color2));
		hsRow1.add(createFieldValueWrapper("93", "HSH_093","Rlxd" , false, false, color1));
		hsRow1.add(createFieldValueWrapper("65", "HSH_065","O", false, false, color2));
		hsRow2.add(createFieldValueWrapper("26", "HSH_026","alt-G/bent-L", false, false, color1));
		hsRow2.add(createFieldValueWrapper("23", "HSH_023","bent-B", false, false, color2));
		hsRow2.add(createFieldValueWrapper("4", "HSH_004", "5", false, false, color1));
		hsRow2.add(createFieldValueWrapper("44","HSH_044", "F/9", false, false, color2));
		hsRow3.add(createFieldValueWrapper("82","HSH_082", "S", false, false, color1));
		hsRow3.add(createFieldValueWrapper("51","HSH_051", "flat-O",  false, false, color2));
		hsRow3.add(createFieldValueWrapper("35","HSH_035", "crvd-5",  false, false, color1));
		hsRow3.add(createFieldValueWrapper("77","HSH_077", "V/2",  false, false, color1));
	}
	
	private JLabel getHandhsapeVisualRepresentation(final SS3FieldValue value) {
		HandShapeImage handshapeImage = new HandShapeImage(value, defaultCodingScheme);

		Image image = handshapeImage.getImage();

		JLabel label = new JLabel();
		Font lblFont = new Font(label.getFont().getName(), Font.PLAIN, 10);
		label.setFont(lblFont);
		label.setBorder(BorderFactory.createLineBorder(UIPalette
				.getBackground()));
		label.setBackground(UIPalette.getBackground());
		label.setOpaque(true);
 		SameWidhtIcon icon = new SameWidhtIcon(image);
		label.setSize(image.getWidth(null) + 5, image.getHeight(null) + 5);
		label.setIcon(icon);

		label.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				value.getId();
				hsClient.setItem(value);
//				SS3Singleton.getApplicationStateController()
//						.setLoadedCollectionUpdated(true);
			}
		});

		return label;
	}
}

