package edu.bu.signstream.grepresentation.fields.gestureField.dialog.handShapes;

import java.io.*;
import java.awt.*;
import java.util.logging.Level;
import javax.imageio.*;
import edu.bu.signstream.common.util.vo.ss3.codingScheme.*;
import edu.bu.signstream.common.files.SSResources;
import edu.bu.signstream.common.util.Util;
import edu.bu.signstream.grepresentation.fields.handShapeField.dialogs.SS3Image;
import edu.bu.signstream.ui.SS3SignStreamApplication;

public class OrientationImage implements SS3Image, Cloneable {

	private Image image;
	private SS3FieldValue value;

    private SS3CodingScheme scheme;

	public OrientationImage(Image image) {
		this.image = image;
	}

	public OrientationImage(SS3FieldValue value, SS3CodingScheme scheme) {
		this.value = value;
		this.scheme = scheme;
		SS3FieldTypeImg img = scheme.getImage(value.getIid());

		if (img == null) {
			return;
		}

		String imgPath = img.getPath();
        this.loadImage(SSResources.resourcesPath + imgPath);
	}

   
   public SS3FieldValue getSS3FieldValue() {
      return this.value;
   }

	private void loadImage(String imgPath) {
		if (imgPath != null) {
			try {
                this.image = ImageIO.read(new File(imgPath));
			} catch (Exception ex) {
				SS3SignStreamApplication.logger.log(Level.SEVERE, "Exception", ex);
			}
		}
	}

	public Image getImage() {
		return this.image;
	}

    @Override
    public OrientationImage clone() {
		SS3FieldValue clonedValue = this.value.cloneFieldValue();
		this.value.setId(Util.uuid());
		return new OrientationImage(clonedValue, this.scheme);
    }
}
