package edu.bu.signstream.grepresentation.fields.gestureField.mouseDelegateListeners;

import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JColorChooser;
import javax.swing.JDialog;

import edu.bu.signstream.grepresentation.requestsHandler.SS3Singleton;
import edu.bu.signstream.grepresentation.fields.Event;
import edu.bu.signstream.grepresentation.fields.nonManualField.NonManualFieldWrapper;

public class ColorActionListener implements ActionListener {
   private NonManualFieldWrapper wrapper = null;
   private JDialog dialog = null;
   private ChangeColorListener changeColorListener = null;
   private JColorChooser chooser = new JColorChooser();

   public ColorActionListener(NonManualFieldWrapper wrapper) {
      this.wrapper = wrapper;
      
      changeColorListener = new ChangeColorListener(chooser, wrapper);
      
      dialog =
         JColorChooser.createDialog(
        		 SS3Singleton.getSignStreamApplication(),
            "Pick A Color",
            true,
            chooser,
            changeColorListener, null);
   }

   public void actionPerformed(ActionEvent e) {
	  Event event = wrapper.getSelectedEvent();
      
      Color color = event.getColor();
      if (color == null) 
         color = Color.DARK_GRAY;
         
      chooser.setColor(color);
      
      dialog.setVisible(true);
   }

   public void destroy() {
	   dialog.removeAll();
	   changeColorListener = null;
	   chooser = null;
	   dialog = null;	   
   }
}

class ChangeColorListener implements ActionListener {
	   private JColorChooser chooser;
	   private NonManualFieldWrapper wrapper;

	   public ChangeColorListener(JColorChooser chooser, NonManualFieldWrapper wrapper) {
	      this.chooser = chooser;
	      this.wrapper = wrapper;
	   }

	   public void actionPerformed(ActionEvent e) {
	      Color color = chooser.getColor();
	      wrapper.getSelectedEvent().setColor(color);
	      SS3Singleton.getApplicationStateController().setLoadedCollectionUpdated(true);
	   }
}


