package edu.bu.signstream.grepresentation.fields.glossField;

import edu.bu.signstream.common.util.Util;
import edu.bu.signstream.common.util.vo.ss3.db.SS3Entity;
import edu.bu.signstream.common.util.vo.ss3.db.SS3Item;
import edu.bu.signstream.time.Time;
import edu.bu.signstream.time.TimeUnit;
import edu.bu.signstream.grepresentation.requestsHandler.SS3Singleton;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;

public class Text { //extends  ChainedEvent {
	private String entityID = "";
	private String itemID = "";
	private String text = "";
	
	private Time startTimeInfo;
	private Time endTimeInfo;
			
	private boolean visible = true;
	private boolean selected = false;

    public Text(String text, Time time) {
        this.text = text;
        this.startTimeInfo = time;
        this.endTimeInfo = time;
        
		entityID = "" + Util.getLongUniqueNumber();
		itemID = "" + Util.getLongUniqueNumber();
    }

	public Text(String text, double startCoord, double endCoord) {
		this.text = text;
		
		SignStreamSegmentPanel segmentPanel = SS3Singleton.getSignStreamApplication().getSignStreamSegmentPanel();

        // JACK TODO: getCurrentRange(field?)
//      var range = Util.getCurrentRange(field);
//      startTimeInfo = TimeRange.ABSOLUTE.time(TimeUnit.COORDINATE, Math.round(startCoord)).in(range);
//      startTimeInfo = TimeRange.ABSOLUTE.time(TimeUnit.COORDINATE, Math.round(endCoord)).in(range);

		Time startMovieTimeInfo = segmentPanel.getZoomer().getCoordinateTimeConvertor()
				.convertCoordinateToTimeInfo(startCoord);
		Time endMovieTimeInfo = segmentPanel.getZoomer().getCoordinateTimeConvertor()
				.convertCoordinateToTimeInfo(endCoord);
		startTimeInfo = startMovieTimeInfo;
		endTimeInfo = endMovieTimeInfo;

        
		entityID = "" + Util.getLongUniqueNumber();
		itemID = "" + Util.getLongUniqueNumber();
	}

	public Text(String entityID, String itemID, String text) {
		this.entityID = entityID;
		this.itemID = itemID;
		this.text = text;
	}
	
	public Time getStartTime() {
		return startTimeInfo;
	}

	public void setStartTimeInfo(Time time) {
	    startTimeInfo = time;
    }
	
	public void setStartTime(double time) {
	    startTimeInfo = SS3Singleton.getVideoTimeRange().time(Math.round(time), TimeUnit.TIMESTAMP);
	}
	
	public Time getEndTime() {
		return endTimeInfo;
	}

	public void setEndTimeInfo(Time time) {
	    endTimeInfo = time;
    }
	
	public void setEndTime(double time) {
        endTimeInfo = SS3Singleton.getVideoTimeRange().time(Math.round(time), TimeUnit.TIMESTAMP);
	}

	public SS3Entity getSS3Entity() {
		SS3Entity entity = new SS3Entity();
		entity.setID(entityID);
		
		SS3Item item = new SS3Item(itemID, startTimeInfo, endTimeInfo);
		item.setText(text);
		item.setTextOnly(true);
		entity.addItem(item);
		
		return entity;
	}
	
	public void setSelected(boolean selected) {
		this.selected = selected;
	}
	
	public boolean isSelected() {
		return selected;
	}

	public void setVisible(boolean visible) {
		this.visible = visible;
	}
	
	public boolean isVisible() {
		return visible;
	}
	
	public String getText() {
		return text;
	}

	public void setText(String text) {
		this.text = text;
	}

	public double getStartCoord() {
		SignStreamSegmentPanel segmentPanel = SS3Singleton.getSignStreamApplication().getSignStreamSegmentPanel();
		return segmentPanel.getZoomer().getCoordinateTimeConvertor().convertTimeInfoToCoordinate(startTimeInfo);
	}

	public void setStartCoord(double startCoord) {
		SignStreamSegmentPanel segmentPanel = SS3Singleton.getSignStreamApplication().getSignStreamSegmentPanel();
		Time startMovieTimeInfo = segmentPanel.getZoomer().getCoordinateTimeConvertor().convertCoordinateToTimeInfo(
				startCoord);
		startTimeInfo = startMovieTimeInfo;
		
		if(getEndCoord() < startCoord) {
			endTimeInfo = startMovieTimeInfo;
		}
	}

	public double getEndCoord() {
		SignStreamSegmentPanel segmentPanel = SS3Singleton.getSignStreamApplication().getSignStreamSegmentPanel();
		return segmentPanel.getZoomer().getCoordinateTimeConvertor().convertTimeInfoToCoordinate(endTimeInfo);
	}

	public void setEndCoord(double endCoord) {
		SignStreamSegmentPanel segmentPanel = SS3Singleton.getSignStreamApplication().getSignStreamSegmentPanel();
		Time endMovieTimeInfo = segmentPanel.getZoomer().getCoordinateTimeConvertor().convertCoordinateToTimeInfo(
				endCoord);
		endTimeInfo = endMovieTimeInfo;
	}
	
	public String getEntityID() {
		return entityID;
	}
	
	public String getItemID() {
		return itemID;
	}
}