package edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

import javax.swing.ButtonGroup;
import javax.swing.JPanel;
import javax.swing.JRadioButton;


public class MovementPanel extends JPanel implements ItemListener { //, ActionListener {
   //private JDialog parentDialog = null;

   private JRadioButton oneHanded = new JRadioButton("One hand moving");
   private JRadioButton twoHanded = new JRadioButton("Two hands moving");

   private JRadioButton sameMovement = new JRadioButton("Same movements");
   private JRadioButton difMovements = new JRadioButton("Different movements");
   
   private JRadioButton symmetrical = new JRadioButton("Symmetrical");
   private JRadioButton antisymmetrical = new JRadioButton("Antisymmetrical");

   //private JButton enter = new JButton("Select");
   //private JButton cancel = new JButton("Clear");

   private final int ONE_HANDED = 1;
   private final int TWO_HANDED = 2;
   private final int SAME_MOVEMENT = 3;
   private final int DIF_MOVEMENTS = 4;
   private final int SYMMETRICAL = 5;
   private final int ANTISYMMETRICAL = 6;

   private final int ENTER = 0;
   private final int CANCEL = 1;

   private ButtonGroup hGrp = new ButtonGroup();
   private ButtonGroup sdGrp = new ButtonGroup();
   private ButtonGroup saGrp = new ButtonGroup();

   private MovementFormBean fBean =null;

   public MovementPanel(MovementFormBean fBean) {
      //this.parentDialog = parentDialog;
      this.fBean = fBean;

      oneHanded.addItemListener(this);
      twoHanded.addItemListener(this);
      sameMovement.addItemListener(this);
      difMovements.addItemListener(this);
      symmetrical.addItemListener(this);
      antisymmetrical.addItemListener(this);

      oneHanded.setActionCommand("" + ONE_HANDED);
      twoHanded.setActionCommand("" + TWO_HANDED);
      sameMovement.setActionCommand("" + SAME_MOVEMENT);
      difMovements.setActionCommand("" + DIF_MOVEMENTS);
      symmetrical.setActionCommand("" + SYMMETRICAL);
      antisymmetrical.setActionCommand("" + ANTISYMMETRICAL);

//      enter.setActionCommand("" + ENTER);
//      cancel.setActionCommand("" + CANCEL);
//      enter.addActionListener(this);
//      cancel.addActionListener(this);

      initUI();
   }

   private void init() {
       
      oneHanded.setSelected(fBean.isOneHandMovindSelected());
      twoHanded.setSelected(fBean.isTwoHandsMovindSelected());
      sameMovement.setSelected(fBean.isSameMovementSelected());
      difMovements.setSelected(fBean.isDifMovementsSelected());
      sameMovement.setEnabled(fBean.isSameMovementEnabled());
      difMovements.setEnabled(fBean.isDifMovementsEnabled());
      
      symmetrical.setSelected(fBean.isSymmetricalMovementSelected());
      antisymmetrical.setSelected(fBean.isAntisymmetricalMovemntSelected());
      symmetrical.setEnabled(fBean.isSymmetricalMovementEnabled());
      antisymmetrical.setEnabled(fBean.isAntisymmetricalMovemntEnabled());
   }

   private void initUI() {
      init();
      
      hGrp.add(oneHanded);
      hGrp.add(twoHanded);
      sdGrp.add(sameMovement);
      sdGrp.add(difMovements);
      saGrp.add(symmetrical);
      saGrp.add(antisymmetrical);

      GridBagLayout gbl = new GridBagLayout();
      GridBagConstraints gbc = new GridBagConstraints();

      setLayout(gbl);

      int hStrut = 45;

      gbc.anchor = GridBagConstraints.NORTHWEST;
      gbc.gridwidth = GridBagConstraints.REMAINDER;

      gbc.gridwidth = 1;
      gbc.insets = new Insets(3, 3, 3, 3);
      gbc.gridwidth = GridBagConstraints.REMAINDER;
      add(oneHanded, gbc);

      gbc.gridwidth = 1;
      gbc.gridwidth = GridBagConstraints.REMAINDER;
      //gbc.fill = GridBagConstraints.NONE;
      add(twoHanded, gbc);
      
      gbc.insets = new Insets(3, 23, 3, 3);
      gbc.gridwidth = GridBagConstraints.REMAINDER;
      gbc.fill = GridBagConstraints.NONE;
      add(sameMovement, gbc);
      
      gbc.insets = new Insets(3, 43, 3, 3);
      gbc.gridwidth = 1;
      gbc.gridwidth = GridBagConstraints.REMAINDER;
      add(symmetrical, gbc);
      
      gbc.gridwidth = 1;
      gbc.gridwidth = GridBagConstraints.REMAINDER;
      add(antisymmetrical, gbc);

      gbc.insets = new Insets(3, 23, 3, 3);
      gbc.gridwidth = GridBagConstraints.REMAINDER;
      gbc.fill = GridBagConstraints.NONE;
      add(difMovements, gbc);

   }

   @Override
public void itemStateChanged(ItemEvent event) {
      JRadioButton obj = (JRadioButton) event.getSource();
      String str = obj.getActionCommand();

      switch (Integer.parseInt(str)) {
         case ONE_HANDED :
           
            break;
         case TWO_HANDED :
            
            break;
         case SAME_MOVEMENT :
            
            break;

         case DIF_MOVEMENTS :
            
            break;

      }
   }
/*
   public void actionPerformed(ActionEvent ae) {
      String str = ae.getActionCommand();

      switch (Integer.parseInt(str)) {
         case ENTER :
            HandShapesPaletteFormBean palletFormBean =
               new HandShapesPaletteFormBean();

            SS3CodingScheme scheme = hshFormBean.getSS3CodingScheme();
            palletFormBean.setCodingScheme(scheme);

            CSLanguage language = scheme.getLanguages().getDefLanguage();

            HandShapePanelDelegate hShapeDelegate =
               new HandShapePanelDelegate(hshFormBean.getSS3CodingScheme());

            if (fingerspelled.isSelected()) {

               boolean fngUnmarked =
                  !((domHndR.isSelected() && fngrsplR.isSelected())
                     || (domHndL.isSelected() && fngrsplL.isSelected()));

               ArrayList items =
                  language.getImmageItems(CSLanguage.ALL, fngUnmarked, true);

               if (fngrsplR.isSelected()) {

                  ArrayList list =
                     scheme.getCorrespondingFieldValues(
                        items,
                        Constants.TYPE_RIGHT_HAND_SHAPE);

                  palletFormBean.setValues(list);
                  palletFormBean.setRightHandSelected(true);
                  palletFormBean.setTitle("Right Hand");
                  palletFormBean.setSelectedHshImages(
                     bean.getSelectedDomHandShapeImages());

               } else {

                  ArrayList list =
                     scheme.getCorrespondingFieldValues(
                        items,
                        Constants.TYPE_LEFT_HAND_SHAPE);

                  palletFormBean.setValues(list);
                  palletFormBean.setRightHandSelected(false);
                  palletFormBean.setTitle("Left Hand");
                  palletFormBean.setSelectedHshImages(
                     bean.getSelectedNdomHandShapeImages());

               }

               FingerspellingHandshapeDialog d =
                  new FingerspellingHandshapeDialog(
                     palletFormBean,
                     bean,
                     hshFormBean.getSS3CodingScheme());

               d.setModal(true);
               d.show();
               d.toFront();

            } else if (oneHanded.isSelected()) {

               boolean oneHndUnmarked =
                  !((domHndR.isSelected() && oneHndR.isSelected())
                     || (domHndL.isSelected() && oneHndL.isSelected()));

               ArrayList items =
                  language.getImmageItems(
                     CSLanguage.ALL,
                     oneHndUnmarked,
                     false);

               if (oneHndR.isSelected()) {

                  ArrayList list =
                     scheme.getCorrespondingFieldValues(
                        items,
                        Constants.TYPE_RIGHT_HAND_SHAPE);

                  palletFormBean.setValues(list);
                  palletFormBean.setRightHandSelected(true);
                  palletFormBean.setTitle("Right Hand");
                  palletFormBean.setSelectedHshImages(
                     bean.getSelectedDomHandShapeImages());

               } else if (oneHndL.isSelected()) {

                  ArrayList list =
                     scheme.getCorrespondingFieldValues(
                        items,
                        Constants.TYPE_RIGHT_HAND_SHAPE);

                  palletFormBean.setValues(list);
                  palletFormBean.setRightHandSelected(false);
                  palletFormBean.setTitle("Left Hand");
                  palletFormBean.setSelectedHshImages(
                     bean.getSelectedNdomHandShapeImages());
               }

               HandshapeDialog d =
                  new HandshapeDialog(
                     palletFormBean,
                     bean,
                     hshFormBean.getSS3CodingScheme(),
                     parentDialog);
               d.setModal(true);
               d.show();
               d.toFront();
            } else if (twoHanded.isSelected()) {

               ArrayList markedItems =
                  language.getImmageItems(CSLanguage.ALL, false, false);

               if (sameHandshapes.isSelected()) {

                  String hndType =
                     domHndR.isSelected()
                        ? Constants.TYPE_RIGHT_HAND_SHAPE
                        : Constants.TYPE_LEFT_HAND_SHAPE;

                  ArrayList list =
                     scheme.getCorrespondingFieldValues(markedItems, hndType);

                  palletFormBean.setValues(list);
                  palletFormBean.setRightHandSelected(true);
                  palletFormBean.setTitle("Right and Left Hands");

                  palletFormBean.setSelectedHshImages(
                     bean.getSelectedDomHandShapeImages());
                  palletFormBean.setSelectedHshImages(
                     bean.getSelectedNdomHandShapeImages());

                  HandshapeDialog d =
                     new HandshapeDialog(
                        palletFormBean,
                        bean,
                        hshFormBean.getSS3CodingScheme(),
                        parentDialog);

                  d.setModal(true);
                  d.show();
                  d.toFront();
               } else if (difHandshapes.isSelected()) {
                  // do right hand  
                  boolean rHndUnmarked = !((domHndR.isSelected() && oneHndR.isSelected()));  
                  ArrayList rhUnmarkedItems =
                     language.getImmageItems(CSLanguage.ALL, rHndUnmarked, false);

                  ArrayList rhList = scheme.getCorrespondingFieldValues(rhUnmarkedItems, Constants.TYPE_RIGHT_HAND_SHAPE);

                  palletFormBean.setValues(rhList);
                  palletFormBean.setRightHandSelected(true);
                  palletFormBean.setTitle("Right Hand");

                  HandShapesPaletteFormBean palletFormBean2 =
                     new HandShapesPaletteFormBean();
                     
                  ArrayList lhUnmarkedItems = language.getImmageItems(CSLanguage.ALL, !rHndUnmarked, false);

                  ArrayList lhList = scheme.getCorrespondingFieldValues(lhUnmarkedItems, Constants.TYPE_LEFT_HAND_SHAPE);                                   

                  palletFormBean2.setValues(lhList);
                  palletFormBean2.setRightHandSelected(false);
                  palletFormBean2.setTitle("Left Hand");

                  DblHandshapeDialog d =
                     new DblHandshapeDialog(
                        palletFormBean,
                        palletFormBean2,
                        bean,
                        hshFormBean.getSS3CodingScheme());

                  d.setModal(true);
                  d.show();
                  d.toFront();
               }
            }

         case CANCEL :
            //prepareAndStartDAISearch();
            break;
      }
      */
    }
