package edu.bu.signstream.grepresentation.fields.nonManualField.mouseDelegateListeners;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import edu.bu.signstream.common.util.ErrorMessages;
import edu.bu.signstream.time.Time;
import edu.bu.signstream.grepresentation.fields.locationField.LocationEntity;
import edu.bu.signstream.grepresentation.fields.signTypeField.SignTypeEntity;
import edu.bu.signstream.grepresentation.requestsHandler.SS3Singleton;
import edu.bu.signstream.grepresentation.fields.Event;
import edu.bu.signstream.grepresentation.fields.glossField.GlossChainedEventsEntity;
import edu.bu.signstream.grepresentation.fields.nonManualField.ChainedEventsEntity;
import edu.bu.signstream.grepresentation.view.main.SignStreamSegmentPanel;
import edu.bu.signstream.grepresentation.view.mediaControl.MediaToolBar;

public class AddOnsetActionListener implements ActionListener {
	private ChainedEventsEntity selectedEntity = null;

	public AddOnsetActionListener() {
	}

	public void setSelectedEntity(ChainedEventsEntity entity) {
		this.selectedEntity = entity;
	}

	@Override
	public void actionPerformed(ActionEvent e) {

//		MediaToolBar mediaToolBar = SS3Singleton.getMediaToolBar(null);
//		Event utterance = selectedEntity.getParentEntity().getEvent();

		SignStreamSegmentPanel segmentPanel = SS3Singleton
				.getSignStreamApplication().getSignStreamSegmentPanel();

//		Time minOnsetStartTimeInfo = segmentPanel.getMultipleMovieController()
//				.getPrecedingFrameTimeInfo(
//						selectedEntity.getStartTimeInfo());

//		if (minOnsetStartTimeInfo.lessThan(utterance.getStartTimeInfo())) {
//			SS3Singleton.getErrorMessages().showErrorMessage(ErrorMessages.EVENT_EXTEND_BEYOND_UTTERANCE);
//			return;
//		}
			
		ChainedEventsEntity prevEntity = selectedEntity.getPreviousEntity();
		if(prevEntity != null) {
			Time minOnsetMovieTimeInfo = segmentPanel.getMultipleMovieController().getFollowingFrameTimeInfo(
					prevEntity.getEndTimeInfo());
			if(selectedEntity.getStartTimeInfo().lessThan(minOnsetMovieTimeInfo)) {
				SS3Singleton.getErrorMessages().showErrorMessage(ErrorMessages.CHAINS_CANNOT_OVERLAP);
				return;
			}
		}

		String seWarning = selectedEntity.addOnsetEvent();
		if (seWarning != null) {
			SS3Singleton.getErrorMessages().showErrorMessage(seWarning);
			return;
		}
		Event selectedEvent = selectedEntity.getOnset();
		selectedEntity.getValueOrTextValueEvent().unselect();
		MediaToolBar mToolBar = SS3Singleton.getMediaToolBar(segmentPanel);
        mToolBar.select(selectedEvent, selectedEntity);

        var currentTime = selectedEvent.getStartTimeInfo();
        SS3Singleton.getMediaPlayer().seek(currentTime);

		if(selectedEntity instanceof GlossChainedEventsEntity) {
			GlossChainedEventsEntity glsSelectedEntity = (GlossChainedEventsEntity)selectedEntity;
			
			if(glsSelectedEntity.isLockedDomNdomAlignments()) {
				GlossChainedEventsEntity ndGlsEntity = glsSelectedEntity.getDependentGlossEntity();
				if(ndGlsEntity != null && ndGlsEntity.getOnset() == null) {
					String ndGlswarning = ndGlsEntity.addOnsetEvent();
					if(ndGlswarning != null) {
						SS3Singleton.getErrorMessages().showErrorMessage(ndGlswarning);	
					}
				}
			}

			LocationEntity depLocEntity = glsSelectedEntity.getDependentLocationEntity();
			if (depLocEntity != null) {
				depLocEntity.updateTimes();
			}
			
			SignTypeEntity depSignTypeEnt = glsSelectedEntity.getDependentSignTypeEntity();
			if (depSignTypeEnt != null) {
				depSignTypeEnt.updateTimes();
			}
		}
		
		SS3Singleton.getApplicationStateController().setLoadedCollectionUpdated(true);
		
		segmentPanel.repaint();
	}
}