package edu.bu.signstream.grepresentation.fields.palettes;

import edu.bu.signstream.common.util.UIPalette;
import edu.bu.signstream.grepresentation.fields.glossField.dialog.associatedFields.FieldValueWrapper;

import javax.swing.*;
import java.awt.*;
import java.util.ArrayList;

public class TriangleLabel extends JLabel {
    private boolean expanded;
    private final FieldValueWrapper wrapper;
    private final ArrayList<FieldValueWrapper> fieldValueWrappers;

    public TriangleLabel(FieldValueWrapper wrapper, ArrayList<FieldValueWrapper> fieldValueWrappers) {
        this.wrapper = wrapper;
        this.fieldValueWrappers = fieldValueWrappers;

        this.setBackground(UIPalette.getBackground());
        this.setPreferredSize(new Dimension(15, 30));
        this.expanded = wrapper.isExpanded();
        this.repaint();

        this.setBorder(BorderFactory.createLineBorder(Color.red));
    }

    public void setExpanded(boolean expanded) {
        this.expanded = expanded;

        for (FieldValueWrapper w : this.fieldValueWrappers) {
            w.setExpanded(expanded);
        }
    }

    public boolean isExpanded() {
        return this.expanded;
    }

    public void click() {
        this.expanded = !this.expanded;
    }

    public void action() {
        this.wrapper.setExpanded(!this.wrapper.isExpanded());
        this.expanded = this.wrapper.isExpanded();
        this.repaint();
    }

    @Override
    public void paint(Graphics g) {
        if (!this.expanded) {
            g.drawLine(3, 3, 3, 12);
            g.drawLine(3, 3, 8, 8);
            g.drawLine(8, 8, 3, 13);
        } else {
            g.drawLine(3, 3, 13, 3);
            g.drawLine(3, 3, 8, 8);
            g.drawLine(8, 8, 13, 3);
        }
    }
}
