package edu.bu.signstream.grepresentation.listener;

import edu.bu.signstream.ui.SS3SignStreamApplication;

import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.lang.ref.WeakReference;
import java.lang.reflect.Method;
import java.util.logging.Level;

public class WeakFocusListener implements FocusListener {  
	  
    private WeakReference<FocusListener> weakListenerReference;  
    private Object source;  
  
    public WeakFocusListener(FocusListener listener, Object source) {  
        this.weakListenerReference = new WeakReference<FocusListener>(listener);  
        this.source = source;  
    }  
    
    public void focusGained(FocusEvent focusEvent) {
        FocusListener focusListener = getFocusListener();
        if(focusListener != null) 
        	focusListener.focusGained(focusEvent);
    }
    
    public void focusLost(FocusEvent focusEvent) {
        FocusListener focusListener = getFocusListener();
        if(focusListener != null) 
        	focusListener.focusLost(focusEvent);
    }
 
    private FocusListener getFocusListener() {
        FocusListener focusListener = (FocusListener) this.weakListenerReference.get();  
        if(focusListener == null) 
            this.removeListener(); 
        return focusListener;
    }
    
    private void removeListener() {  
        try {  
            Method method = source.getClass().getMethod("removeFocusListener", new Class[] {FocusListener.class});  
            method.invoke(source, new Object[] {this});  
        } catch(Exception ex) {  
            ex.printStackTrace();
            SS3SignStreamApplication.logger.log(Level.SEVERE, "Exception", ex);
        }  
    }  
}
