package edu.bu.signstream.grepresentation.view;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Font;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.MouseEvent;
import java.util.EventObject;
import java.util.Vector;

import javax.swing.AbstractCellEditor;
import javax.swing.JCheckBox;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTree;
import javax.swing.UIManager;
import javax.swing.event.ChangeEvent;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeCellRenderer;
import javax.swing.tree.TreeCellEditor;
import javax.swing.tree.TreeCellRenderer;
import javax.swing.tree.TreePath;

import edu.bu.signstream.common.util.UIPalette;
import edu.bu.signstream.grepresentation.requestsHandler.SS3Singleton;

public class ShowSegmentsDialog extends JDialog {
	
	public ShowSegmentsDialog() {
		super(SS3Singleton.getSignStreamApplication(), "Select utterances");
		initDialog();
	}

	public void initDialog() {
		JPanel panel = new JPanel();
		panel.setLayout(new BorderLayout());
//
	    CheckBoxNode MacroUnit1TP1Segment1[] = {
		        new CheckBoxNode("John buy house1", true),
		        new CheckBoxNode("John buy house2", true)};
		  
		CheckBoxNode MacroUnit1TP1Segment2[] = {
			    new CheckBoxNode("John buy house by Marry", true),
			    new CheckBoxNode("John buy house by Andrew", false)};       

		Vector tpr1s1 = new NamedVector("Segment 1", MacroUnit1TP1Segment1); 
		Vector tpr1s2 = new NamedVector("Segment 2", MacroUnit1TP1Segment2);
		
		Object rootNodes[] = { tpr1s1, tpr1s2 };
	    Vector rootVector = new NamedVector("Temporal Partition 1", rootNodes);
	    
	    Object rootRootNodes[] = {rootVector}; 
	    Vector rootRootVector = new NamedVector("MacroUnit1", rootRootNodes);	
	    
	    JTree tree = new JTree(rootRootVector);
	    
	    for (int i = 0; i < tree.getRowCount(); i++) {
	         tree.expandRow(i);
	    }
	    
	    CheckBoxNodeRenderer renderer = new CheckBoxNodeRenderer();
	    
	    int fontSize = 12, fontStyle = Font.PLAIN;
	    String fontFamily = "Times-Roman";
	    Font font = new Font(fontFamily, fontStyle, fontSize);
	    tree.setFont(font);
		tree.setCellRenderer(renderer);
		tree.setCellEditor(new CheckBoxNodeEditor(tree));
		tree.setEditable(true);

		JScrollPane scrollPane = new JScrollPane(tree);
		scrollPane.getViewport().setScrollMode(javax.swing.JViewport.SIMPLE_SCROLL_MODE);
		
		panel.add(scrollPane, BorderLayout.CENTER);
		panel.setPreferredSize(scrollPane.getPreferredSize());
//		
		Container contentPane = getContentPane();
		contentPane.setLayout(new BorderLayout(50, 50));
		contentPane.add(panel, BorderLayout.CENTER);
		this.pack();
	}

	//
	
	  public static void main(String args[]) {
		    JFrame frame = new JFrame("CheckBox Tree");

		    //CheckBoxNode accessibilityOptions[] = {
		    //    new CheckBoxNode(
		    //        "Move system caret with focus/selection changes", false),
		    //    new CheckBoxNode("Always expand alt text for images", true) };
		    
		    CheckBoxNode MacroUnit1TP1Segment1[] = {
			        new CheckBoxNode("John buy house1", true),
			        new CheckBoxNode("John buy house2", true)};
			  
			CheckBoxNode MacroUnit1TP1Segment2[] = {
				    new CheckBoxNode("John buy house by Marry", true),
				    new CheckBoxNode("John buy house by Andrew", false)};       

			Vector tpr1s1 = new NamedVector("Segment 1", MacroUnit1TP1Segment1); 
			Vector tpr1s2 = new NamedVector("Segment 2", MacroUnit1TP1Segment2);
			
			Object rootNodes[] = { tpr1s1, tpr1s2 };
		    Vector rootVector = new NamedVector("Temporal Partition 1", rootNodes);
		    
		    Object rootRootNodes[] = {rootVector}; 
		    Vector rootRootVector = new NamedVector("MacroUnit1", rootRootNodes);
		
//		    CheckBoxNode MacroUnit1TP1[] = {
//			        new CheckBoxNode("Notify when downloads complete", true),
//			        new CheckBoxNode("Disable script debugging", true),
//			        new CheckBoxNode("Use AutoComplete", true),
//			        new CheckBoxNode("Browse in a new process", false) };
//		    
//		    CheckBoxNode MacroUnit1[] = {
//		        new CheckBoxNode("Notify when downloads complete", true),
//		        new CheckBoxNode("Disable script debugging", true),
//		        new CheckBoxNode("Use AutoComplete", true),
//		        new CheckBoxNode("Browse in a new process", false) };
//		    //Vector accessVector = new NamedVector("Accessibility",
//		    //    accessibilityOptions);
//		    Vector browseVector = new NamedVector("Browsing", browsingOptions);
//		    Object rootNodes[] = { accessVector, browseVector };
//		    Vector rootVector = new NamedVector("Root", rootNodes);
		    JTree tree = new JTree(rootRootVector);
		    
		    for (int i = 0; i < tree.getRowCount(); i++) {
		         tree.expandRow(i);
		    }
		    
		    CheckBoxNodeRenderer renderer = new CheckBoxNodeRenderer();
		    
		    //
		     int fontSize = 12, fontStyle = Font.PLAIN;
		      String fontFamily = "Times-Roman";
		      Font font = new Font(fontFamily, fontStyle, fontSize);

//		      renderer.setLeafIcon(null);
//		      renderer.setIcon(null);
//		      renderer.setClosedIcon(null);
//		      renderer.setOpenIcon(null);
//		      renderer.setBackground(UIPalette.getBackground());
//		      renderer.setBackgroundNonSelectionColor(UIPalette.getBackground());
//		      renderer.setBackgroundSelectionColor(UIPalette.getBackgroundSelection());
//		      renderer.setBorderSelectionColor(UIPalette.getBackgroundSelection());
		      tree.setFont(font);
		    //
		    tree.setCellRenderer(renderer);

		    tree.setCellEditor(new CheckBoxNodeEditor(tree));
		    tree.setEditable(true);

		    JScrollPane scrollPane = new JScrollPane(tree);
			scrollPane.getViewport().setScrollMode(javax.swing.JViewport.SIMPLE_SCROLL_MODE);
		    frame.getContentPane().add(scrollPane, BorderLayout.CENTER);
		    frame.setSize(300, 150);
		    frame.setVisible(true);
//		  }
		}
}

		class CheckBoxNodeRenderer implements TreeCellRenderer {
		  private JCheckBox leafRenderer = new JCheckBox();

		  private DefaultTreeCellRenderer nonLeafRenderer = new DefaultTreeCellRenderer();

		  Color selectionBorderColor, selectionForeground, selectionBackground,
		      textForeground, textBackground;

		  protected JCheckBox getLeafRenderer() {
		    return leafRenderer;
		  }

		  public CheckBoxNodeRenderer() {
		    Font fontValue;
		    fontValue = UIManager.getFont("Tree.font");
		    if (fontValue != null) {
		      leafRenderer.setFont(fontValue);
		    }
		    Boolean booleanValue = (Boolean) UIManager
		        .get("Tree.drawsFocusBorderAroundIcon");
		    leafRenderer.setFocusPainted((booleanValue != null)
		        && (booleanValue.booleanValue()));
		    
		    //
//		    renderer.setBackground(UIPalette.getBackground());
//		      renderer.setBackgroundNonSelectionColor(UIPalette.getBackground());
//		      renderer.setBackgroundSelectionColor(UIPalette.getBackgroundSelection());
//		      renderer.setBorderSelectionColor(UIPalette.getBackgroundSelection());
		    //

		    selectionBorderColor = UIPalette.getBackgroundSelection();
		    selectionForeground = UIManager.getColor("Tree.selectionForeground");
		    selectionBackground = UIManager.getColor("Tree.selectionBackground");
		    textForeground = UIManager.getColor("Tree.textForeground");
		    textBackground = UIManager.getColor("Tree.textBackground");
		  }

		  @Override
		public Component getTreeCellRendererComponent(JTree tree, Object value,
		      boolean selected, boolean expanded, boolean leaf, int row,
		      boolean hasFocus) {

		    Component returnValue;
		    if (leaf) {

		      String stringValue = tree.convertValueToText(value, selected,
		          expanded, leaf, row, false);
		      leafRenderer.setText(stringValue);
		      leafRenderer.setSelected(false);

		      leafRenderer.setEnabled(tree.isEnabled());

		      if (selected) {
		        leafRenderer.setForeground(selectionForeground);
		        leafRenderer.setBackground(selectionBackground);
		      } else {
		        leafRenderer.setForeground(textForeground);
		        leafRenderer.setBackground(textBackground);
		      }

		      if ((value != null) && (value instanceof DefaultMutableTreeNode)) {
		        Object userObject = ((DefaultMutableTreeNode) value)
		            .getUserObject();
		        if (userObject instanceof CheckBoxNode) {
		          CheckBoxNode node = (CheckBoxNode) userObject;
		          leafRenderer.setText(node.getText());
		          leafRenderer.setSelected(node.isSelected());
		        }
		      }
		      returnValue = leafRenderer;
		    } else {
		      returnValue = nonLeafRenderer.getTreeCellRendererComponent(tree,
		          value, selected, expanded, leaf, row, hasFocus);
		    }
		    return returnValue;
		  }
		}

		class CheckBoxNodeEditor extends AbstractCellEditor implements TreeCellEditor {

		  CheckBoxNodeRenderer renderer = new CheckBoxNodeRenderer();

		  ChangeEvent changeEvent = null;

		  JTree tree;

		  public CheckBoxNodeEditor(JTree tree) {
		    this.tree = tree;
		  }

		  @Override
		public Object getCellEditorValue() {
		    JCheckBox checkbox = renderer.getLeafRenderer();
		    CheckBoxNode checkBoxNode = new CheckBoxNode(checkbox.getText(),
		        checkbox.isSelected());
		    return checkBoxNode;
		  }

		  @Override
		public boolean isCellEditable(EventObject event) {
		    boolean returnValue = false;
		    if (event instanceof MouseEvent) {
		      MouseEvent mouseEvent = (MouseEvent) event;
		      TreePath path = tree.getPathForLocation(mouseEvent.getX(),
		          mouseEvent.getY());
		      if (path != null) {
		        Object node = path.getLastPathComponent();
		        if ((node != null) && (node instanceof DefaultMutableTreeNode)) {
		          DefaultMutableTreeNode treeNode = (DefaultMutableTreeNode) node;
		          Object userObject = treeNode.getUserObject();
		          returnValue = ((treeNode.isLeaf()) && (userObject instanceof CheckBoxNode));
		        }
		      }
		    }
		    return returnValue;
		  }

		  @Override
		public Component getTreeCellEditorComponent(JTree tree, Object value,
		      boolean selected, boolean expanded, boolean leaf, int row) {

		    Component editor = renderer.getTreeCellRendererComponent(tree, value,
		        true, expanded, leaf, row, true);

		    // editor always selected / focused
		    ItemListener itemListener = new ItemListener() {
		      @Override
			public void itemStateChanged(ItemEvent itemEvent) {
		        if (stopCellEditing()) {
		          fireEditingStopped();
		        }
		      }
		    };
		    if (editor instanceof JCheckBox) {
		      ((JCheckBox) editor).addItemListener(itemListener);
		    }

		    return editor;
		  }
		}

class NamedVector extends Vector {
		  String name;

		  public NamedVector(String name) {
		    this.name = name;
		  }

		  public NamedVector(String name, Object elements[]) {
		    this.name = name;
		    for (int i = 0, n = elements.length; i < n; i++) {
		      add(elements[i]);
		    }
		  }

		  @Override
		public String toString() {
		    return name;
		  }
		}
