package edu.bu.signstream.media;

import edu.bu.signstream.time.Duration;
import edu.bu.signstream.time.TimeRange;
import edu.bu.signstream.ui.frame.SSFrame;

import java.net.URI;

public class AudioInfo implements Audio {
    private final URI uri;
    private final int order;
    private final Duration duration;
    private final TimeRange range;

    private final int rate;

    public AudioInfo(Audio audio) {
        this.uri = audio.uri();
        this.order = audio.order();
        this.duration = audio.duration();
        this.range = audio.range();

        this.rate = audio.rate();
    }

    public AudioInfo(URI uri, int order, TimeRange range, Duration duration, int rate) {
        this.uri = uri;
        this.order = order;
        this.range = range;
        this.duration = duration;

        this.rate = rate;
    }

    @Override
    public URI uri() { return uri; }
    
    @Override
	public int order() { return order; }

    @Override
    public Duration duration() { return duration; }

    @Override
    public TimeRange range() { return range; }

    @Override
    public void range(TimeRange range) { throw new UnsupportedOperationException(); }

    @Override
    public int rate() { return rate; }

    @Override
    public SSFrame view() { throw new UnsupportedOperationException(); }

    @Override
    public void display() { throw new UnsupportedOperationException(); }

    @Override
    public void hide() { throw new UnsupportedOperationException(); }

    @Override
    public boolean displayed() { return false; }
}
