package edu.bu.signstream.media;

import edu.bu.signstream.time.Duration;
import edu.bu.signstream.time.TimeRange;
import edu.bu.signstream.ui.frame.SSFrame;

import javax.swing.*;
import java.net.URI;

public class VideoInfo implements Video {
    private final URI uri;
    private int order;
    private final Duration duration;
    private final TimeRange range;

    private final int width;
    private final int height;
    private final double framerate;

    public VideoInfo(Video video) {
        this.uri = video.uri();
        this.order = video.order();
        this.duration = video.duration();
        this.range = video.range();

        this.width = video.width();
        this.height = video.height();
        this.framerate = video.framerate();
    }

    public VideoInfo(URI uri, int order, Duration duration, TimeRange range, int width, int height, double framerate) {
        this.uri = uri;
        this.order = order;
        this.duration = duration;
        this.range = range;

        this.width = width;
        this.height = height;
        this.framerate = framerate;
    }

    @Override
    public URI uri() { return uri; }
    
    @Override
	public int order() { return order; }

    @Override
    public Duration duration() { return duration; }

    @Override
    public TimeRange range() { return range; }

    @Override
    public void range(TimeRange range) { throw new UnsupportedOperationException(); }

    @Override
    public int width() { return width; }

    @Override
    public int height() { return height; }

    @Override
    public double framerate() { return framerate; }

    @Override
    public int timestep() { return 1001; }

    @Override
    public int timebase() { return 30000; }

    @Override
    public JComponent image() { throw new UnsupportedOperationException(); }

    @Override
    public SSFrame view() { throw new UnsupportedOperationException(); }

    @Override
    public void display() { throw new UnsupportedOperationException(); }

    @Override
    public void hide() { throw new UnsupportedOperationException(); }

    @Override
    public boolean displayed() { return false; }
}
