package edu.bu.signstream.media.fileNavigation;

import java.io.File;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;

import edu.bu.signstream.grepresentation.requestsHandler.SS3Singleton;
import edu.bu.signstream.ui.panels.table.sortable.CSFieldTableSorter;

public class MediaTable extends JTable {

	public MediaTable(CSFieldTableSorter sorter) {
		super(sorter);

		addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent me) {
				if ((me.getModifiers() & InputEvent.CTRL_MASK) == InputEvent.CTRL_MASK) {
					JTable table = (JTable) me.getSource();
					Point p = me.getPoint();
					int rowIndex = table.rowAtPoint(p);
					int colIndex = table.columnAtPoint(p);
					int realColumnIndex = convertColumnIndexToModel(colIndex);

					if (realColumnIndex == 1) {
						File file = (File) table.getValueAt(rowIndex, 1);

						JFileChooser chooser = null;

						if (file.exists()) {
							chooser = new JFileChooser(file);
						} else {
							String str = SS3Singleton.getMediaFilesLocator()
									.getLastLoadedDirectory();
							chooser = new JFileChooser(new File(str));
						}

						chooser.setName(file.getName());
						chooser.setDialogTitle(file.getName());
						chooser.addChoosableFileFilter(new MovieFilter());
						int state = chooser.showOpenDialog(table);

						if (state == JFileChooser.APPROVE_OPTION) {
							File selectedFile = chooser.getSelectedFile();
							String path = selectedFile.getParentFile().getPath();
							SS3Singleton.getMediaFilesLocator().setLastLoadedDirectory(path);
							table.getModel().setValueAt(selectedFile, rowIndex,
									1);
						}
					}
				}
			}
		});
	}
}
