package edu.bu.signstream.media.ui;

import edu.bu.signstream.media.ui.icon.ToggleIconDark;

import javax.swing.*;
import java.awt.*;
import java.util.function.Function;

public class ToggleButton extends JButton {
    private boolean state;
    private final Function<Boolean, Icon> icon;

    public ToggleButton(Function<Boolean, Icon> icon, boolean state) {
        this.icon = icon;
        this.state = state;

        setIcon(icon.apply(state));
        setFocusable(false);
        setBorderPainted(false);
        setPreferredSize(new Dimension(24, 22));
    }

    public ToggleButton(Function<Boolean, Icon> icon) {
        this(icon, true);
    }

    public boolean state() {
        return state;
    }

    public void toggle() {
        state = !state;
        setIcon(icon.apply(state));
    }

    public void set(boolean state) {
        this.state = state;
        setIcon(icon.apply(state));
    }
}
