package edu.bu.signstream.ui.panels;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JDialog;

import edu.bu.signstream.grepresentation.requestsHandler.SS3Singleton;
import edu.bu.signstream.grepresentation.view.UtteranceView;

public class SegmentSelectionDialog extends JDialog {

	private static final long serialVersionUID = 1L;
	
	private SegmentSelectionPanel segmentSelectionPanel = null;
	
	public SegmentSelectionDialog(UtteranceView utteranceView) {
		super(SS3Singleton.getSignStreamApplication());
		
		segmentSelectionPanel = new SegmentSelectionPanel(this, utteranceView);
//		setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
		setPreferredSize(new Dimension(230, 260));	
		setResizable(false);

		addWindowListener(new WindowAdapter() {
            @Override
            public void windowClosing(WindowEvent e) {
                SS3Singleton.getSignStreamApplication().unblock();
            }
        });

		Container contentPane = getContentPane();
		contentPane.setLayout(new BorderLayout(50, 50));
		contentPane.add(segmentSelectionPanel, BorderLayout.CENTER);
		this.pack();
	}

	@Override
    public void setVisible(boolean b) {
	    if (b)
            SS3Singleton.getSignStreamApplication().block();
	    else
            SS3Singleton.getSignStreamApplication().unblock();

        super.setVisible(b);
    }

    @Override
    public void dispose() {
        SS3Singleton.getSignStreamApplication().unblock();

        super.dispose();
    }

	public SegmentSelectionPanel getSegmentSelectionPanel() {
		return segmentSelectionPanel;
	}

}
